<?php

require 'xmlrpc.inc.php';

define('ACCESS_DENY', -1);
define('ACCESS_READ',  1);
define('ACCESS_WRITE', 2);
define('ACCESS_ADMIN', 3);
define('ACCESS_OWNER', 4);

class GLS {
  var $glsDba;
  var $privateKey;

  function GLS(&$glsDba) {
    $this->glsDba=&$glsDba;
    //    SSL
    //    $this->privateKey = openssl_get_privatekey($GLOBALS['gls_cfg']['private_key']);

  }



  /*
  *
  * returns array(bool success of call, function result if call was successed)
  *
  **/
  function remoteCall($hostId, $functionName, $args = null) {

    if ($hostId==0) return '' ;
    $xml = $this->_prepareXmlRpc($functionName, $args);

    $host = $this->glsDba->getHost($hostId);

    //    SSL
    //    $publicKey = openssl_get_publickey($host['public_key']);
    $publicKey='';
    $data = $this->_encryptAndSing($xml, $publicKey);

    $response = $this->_sendRequest($host['gls_url'], $data);
    if (!$response) {
      return array(false, null);
    }

    $xml = $this->_decryptAndVerify($response, $publicKey);
    if (!$xml) {
      return array(false, null);
    }

    return $this->_adjustResponse($xml);
  }

  function remoteCallOnAll($functionName, $args = null) {
    $hosts = $this->getHosts();
    foreach($hosts as $host) {
      remoteCall($host['id'], $functionName, $args);
    }
  }



  function getHosts() {
    return $this->glsDba->getHosts();
  }

  function addHost($glsUrl, $name, $publicKey) {
    $this->glsDba->addHost($glsUrl, $name, $publicKey);
  }

  function removeHost($id) {
    return $this->glsDba->removeHost($id);
  }



  function serviceRequest($fromGlsUrl, $cryptedRequest) {
    $host = $this->glsDba->getHostByGlsUrl($fromGlsUrl);
    //    SSL
    //    $publicKey = openssl_get_publickey($host['public_key']);
    $publicKey = '';

    $xml = $this->_decryptAndVerify($cryptedRequest, $publicKey);
    if (!$xml) {
      return false;
    }

    $request = XMLRPC_parse($xml);
    $method = XMLRPC_getMethodName($request);
    $params = XMLRPC_getParams($request);

    if(!in_array($method, $GLOBALS['gls_cfg']['remote_functions'])){
      return false;
    }

    $return = call_user_func_array('remote_'.$method, $params);

    $data['methodResponse']['params']['param']['value'] = &$return;
    $xml = XML_serialize(&$data);

    $data = $this->_encryptAndSing($xml, $publicKey);

    header("Connection: close");
    header("Content-Length: " . strlen($data));
    header("Content-Type: text/xml");
    header("Date: " . date("r"));
    $server = $GLOBALS['gls_cfg']['server'];
    if($server){
      header("Server: $server");
    }
    echo $data;
    return true;
  }



  function _prepareXmlRpc($method, $params) {
    $data['methodCall']['methodName'] = $method;
    $paramCount = count($params);
    if(!$paramCount){
      $data['methodCall']['params'] = null;
    }else{
      for($n = 0; $n<$paramCount; $n++){
        $data['methodCall']['params']['param'][$n]['value'] = $params[$n];
      }
    }
    return XML_serialize($data);
  }



  /*    SSL
  function _encryptAndSing($data, $publicKey) {
  $data .= str_pad(gmmktime(), 16);
  openssl_seal($data, $sealed, $ekeys, array($publicKey)); //     PHP
  openssl_sign($data, $signature, $this->privateKey);
  return $signature.$ekeys[0].$sealed;
  }



  function _decryptAndVerify($data, $publicKey) {
  $signature = substr($data, 0, 128);
  $ekey = substr($data, 128, 128);
  $sealed = substr($data, 256);

  openssl_open($sealed, $data, $ekey, $this->privateKey);
  $res = openssl_verify($data, $signature, $publicKey);
  if ($res!=1) {
  return false;
  }

  $time = substr($data, -16);
  $data = substr($data, 0, -16);

  $interval = $GLOBALS['gls_cfg']['remote_call_validity_time'];
  if (gmmktime()-intval($time)>$interval) {
  return false;
  }

  return $data;
  }
  */

  // Start    SSL
  function _encryptAndSing($data, $publicKey) {
    $data .= str_pad(gmmktime(), 16);
    return $data;
  }

  function _decryptAndVerify($data, $publicKey) {

    $time = substr($data, -16);
    $data = substr($data, 0, -16);

    $interval = $GLOBALS['gls_cfg']['remote_call_validity_time'];
    if (gmmktime()-intval($time)>$interval) {
      return false;
    }

    return $data;
  }
  // Finish    SSL


  function _sendRequest($url, $data) {
    $pos = strpos($url, '/', 7);
    $location = substr($url, $pos);
    $site = substr($url, 7, $pos-7);
    $site = explode(':', $site);
    if(isset($site[1]) and is_numeric($site[1])){
      $port = $site[1];
    }else{
      $port = 80;
    }
    $site = $site[0];
    $conn = fsockopen($site, $port);
    if(!$conn){
      return false;
    }else{
      $user_agent = $GLOBALS['gls_cfg']['user_agent'];

      $headers =
      "POST $location HTTP/1.0\r\n" .
      "Host: $site\r\n" .
      "Connection: close\r\n" .
      "User-Agent: $user_agent\r\n".
      "Content-Type: text/xml\r\n" .
      "Content-Length: ".strlen($data)."\r\n\r\n";

      fputs($conn, $headers);
      fputs($conn, $data);

      $response = "";
      while(!feof($conn)){
        $response .= fgets($conn, 1024);
      }
      fclose($conn);

      return substr($response, strpos($response, "\r\n\r\n")+4);
    }
  }



  function _adjustResponse($xml) {
    $data = XML_unserialize($xml);

    if(isset($data['methodResponse']['fault'])){
      //XMLRPC_adjustValue(&$data['methodResponse']['fault']['value'])
      array(false, null);
    }else{
      return array(true, XMLRPC_adjustValue(&$data['methodResponse']['params']['param']['value']));
    }
  }

  /*
  *  Start Ivan Maroz
  */

  //      MySQL
  function mysql_count($table, $where="1=1"){
    $query="SELECT COUNT(*) as cnt FROM `$table` WHERE $where";
//    print $query."<br>";

    $result=mysql_query($query);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }
    $row=@mysql_fetch_assoc($result);
    return $row['cnt'];
  }

  function sql_insert($table, $fields, $noescape=array()){
    $query="INSERT INTO `$table` SET ";
    foreach ($fields as $k => $v) {
      $query.="`$k`=";
      if (in_array($k, $noescape)){
        $query.=$v.", ";
      }else{
        $query.="'".mysql_escape_string($v)."', ";
      }
    }
    $query= substr($query, 0, -2);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }
    mysql_query($query);
    return mysql_insert_id();
  }

  function sql_query($query){
    $result=mysql_query($query);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }

    return $result;
  }

  function sql_getOne($query){
    $result=mysql_query($query);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }

    if (mysql_num_rows($result)){
      $row=@mysql_fetch_assoc($result);
    }else{
      $row=array();
    }
    return $row;
  }

  function sql_getAll($query){
    $data=array();
    $result=mysql_query($query);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }
    while ($row = @mysql_fetch_assoc($result)) {
      $data[]=$row;
    }
    return $data;
  }

  function moveforum($what,$where,$from,$userid) {
    $what=intval($what);
    $where=intval($where);
    $from=intval($from);
    $userid=intval($userid);

    if ($this->folderType($where)!='PublicForum'){
        $sql = "SELECT * FROM gls_forums WHERE id=$what" ;
        $res = $this->mysql_count ("gls_forums", "id=$what");
        if (($res)>0)
        {
                $row = $this->mysql_count ("gls_forums2folders", "forum_id=$what AND folder_id=$where") ;
                if ($row==0)
                {
                        $row = $this->mysql_count ("gls_forums2folders", "forum_id=$what AND folder_id=$from") ;
                        if ($row != 0)  $sql = "UPDATE gls_forums2folders SET folder_id=$where WHERE forum_id=$what AND folder_id=$from" ;
                        else $sql = "INSERT INTO gls_forums2folders VALUES ($what, $where)" ;
                        $this->sql_query($sql);
                }
        }
    }
    return false;
  }

  function moveforum_f($ids,$toid,$fromid,$userid) {
    $ids=substr($ids,0,-1);
    $myarr=explode(',',$ids);
    while (list($k,$v) = each($myarr)) {
      $this->moveforum($v,$toid,$fromid,$userid);
    }
  }

  function getGlobalSettings(){
    $query="SELECT * FROM `gls_globalsettings`";
    $result=mysql_query($query);
    if (mysql_errno()){
      die('<br>'.htmlspecialchars($query).'<br><b>Error: </b> <i>'.__FUNCTION__.'</i> -- '.mysql_error().'<br>');
    }

    $data=array();
    while ($row = @mysql_fetch_assoc($result)) {
      $data[$row['name']]=$row['value'];
    }
    return $data;
  }

  function setGlobalSettings($setting){
    if ((is_array($setting))and(count($setting)>0)){
      foreach ($setting as $k => $v) {
        $query="REPLACE `gls_globalsettings` SET `name`='".mysql_escape_string($k)."', `value`='".mysql_escape_string($v)."'";
        mysql_query($query);
      }
      return true;
    }
    return false;
  }

  function getMB($id){
    $query="SELECT id FROM `gls_folders` WHERE `user_id`=".intval($id)." AND `type`='MainBox'";
    $row=mysql_fetch_assoc(mysql_query($query));
    return $row['id'];
  }

  function getpseudoslist4user($userid, $username) {
    $userid=intval($userid);

    $myres=array();
    $res1=mysql_query("SELECT id,name,comment,comment2,create_date FROM gls_pseudos WHERE user_id=$userid");
    while ($row1=mysql_fetch_array($res1)) {
      if ($username==$row1['name']){
        $row1['del']='N';
      }else{
        $row1['del']='Y';
      }
      foreach ($row1 as $key => $val) $row1[$key] = htmlspecialchars($val);
      $myres[]=$row1;
      
    }
    return $myres;
  }

  function getAllPseudos(){
    $query="SELECT * FROM gls_pseudos";
    $result=mysql_query($query);
    $output=array();
    while ($row = mysql_fetch_assoc($result)) {
      $output[$row['id']]=$row;
    }
    return $output;
  }

  function getPostedPseudos($id, $limit=5){
    $id=intval($id);
    $limit=intval($limit);
    $query="SELECT t1.pseudo_id, t1.host_id
FROM `gls_messages` t1, gls_threads t2, gls_forums t3
WHERE t3.id=$id AND t2.forum_id=t3.id AND t1.thread_id=t2.id";
    if ($limit!==0){
      $query.=" LIMIT ".$limit;
    }
    $query.=" ORDER BY host_id ASC";
    $result=mysql_query($query);
    $output=array();
    while ($row = mysql_fetch_assoc($result)) {
      if (($row['pseudo_id']!='')and($row['pseudo_id']>0)){
        $output[$row['host_id']][$row['pseudo_id']]=$row;
      }
    }
    foreach ($output as $k => $datahost) {
      $id=array();
      foreach ($datahost as $d => $v) {
        //        if (($v['pseudo_id']!='')and($v['pseudo_id']>0)){
        $id[]=$v['pseudo_id'];
        //        }
      }
      $str_id=implode(",", $id);
      if ($k===0){
        if ($str_id){
          $query="SELECT * FROM `gls_pseudos` WHERE id IN ($str_id)";
          $res=$this->sql_getAll($query);
          foreach ($res as $r) {
            $r['host']=$k;
            $output[$k][$r['id']]=$r;
          }
        }
      }else{
        $res=$this->remoteCall($k, "getcontactlist", array(serialize($id)));
        $contact=unserialize($res[1]);
        foreach ($contact as $c => $r) {
          $r['host']=$k;
          $output[$k][$r['id']]=$r;
        }
      }
    }

    return $output;
  }

  function removepseudo($id) {
    mysql_query("DELETE FROM gls_pseudos WHERE id=".intval($id));
    //    mysql_query("delete from forums_blacklist where pseudo_id=$id;");
    return true;
  }

  function newpseudo($name,$com,$com2,$uid) {
    if ($this->mysql_count('gls_pseudos', "`name`='".mysql_escape_string($name)."'")){
      return false;
    }else{
      $query="INSERT INTO `gls_pseudos` SET `name`='".mysql_escape_string($name)."',
      `comment`='".mysql_escape_string($com)."',
      `comment2`='".mysql_escape_string($com2)."',
      `user_id`='".intval($uid)."',
      `create_date`=NOW(),
      `can_invite`='Y'";
      mysql_query($query);
      return true;
    }
  }

  function renamefolder($id,$name, $userid){
    $query="UPDATE `gls_folders` SET `name`='".mysql_escape_string($name)."' WHERE `id`=".intval($id)." AND `user_id`=".intval($userid);
    mysql_query($query);
    return true;
  }

  function rightlogin($login,$psw,&$id)
  {
    $res1=mysql_query('select login,pass,id from gls_users where login=\''.mysql_escape_string($login).'\';');
    if ($row1=mysql_fetch_array($res1))
    {
      if ($row1['pass']==$psw) {$id=$row1['id']; return 0;} else {return 2;}
    } else {
      return 1;
    }
  }

  function getusersomesettings($uid) {
    $uid=intval($uid);
    $row1=mysql_fetch_array(mysql_query("select * from forums_somesettings where user_id=".$uid));
    if ($row1==false) {
      $row1=array();
      $row1['default_page']='index.php';
      $row1['datinglink_ontop']='N';
      $row1['user_id']=$uid;
    }
    return $row1;
  }

  function gettranslationindex4user($id) {
    $id=intval($id);
        if ($id==0)
        {
            $row1=mysql_fetch_array(mysql_query("select id from forums_lang_translations limit 1"));
            return $row1['id'];
        }
    $row1=mysql_fetch_array(mysql_query("select trans_id from gls_users where id=$id;"));
    return $row1['trans_id'];
  }

  function getcontactlist($userid) {
    $userid=intval($userid);

    $myarr=array();
    //      
    $query="SELECT DISTINCT gls_pseudos.id,gls_pseudos.name,gls_pseudos.comment, gls_contacts.email, gls_contacts.mycomment, gls_contacts.id emailid FROM gls_contacts,gls_pseudos WHERE (gls_contacts.user_id=$userid) AND (gls_contacts.pseudo_id=gls_pseudos.id) AND gls_contacts.host_id=0";
    $res1=mysql_query($query);
    while ($row1=@mysql_fetch_assoc($res1)) {
      //      $data=$this->sql_getOne("SELECT * FROM gls_pseudos WHERE id=".$row1['pseudo_id']);
      //      print_r($data);
      //      $row1=$data;
      $row1['host_id']=0;
      global $gls_cfg ;
      $row1['host_name']=$gls_cfg['ourname'];


      array_push($myarr,$row1);
    }

    //     
    $query="SELECT DISTINCT email, id emailid, mycomment FROM gls_contacts WHERE user_id=$userid AND pseudo_id=0";
    $res1=mysql_query($query);
    while ($row1=@mysql_fetch_assoc($res1)) {
      //      $data=$this->sql_getOne("SELECT * FROM gls_pseudos WHERE id=".$row1['pseudo_id']);
      //      print_r($data);
      //      $row1=$data;
      $row1['host_id']=0;
      $row1['host_name']='0';
      array_push($myarr,$row1);
    }

    //      
    $res1=mysql_query("SELECT DISTINCT `host_id` FROM gls_contacts WHERE user_id=$userid AND host_id<>0 AND host_id IS NOT NULL");
    while ($row1=mysql_fetch_assoc($res1)) {
      $host=$this->glsDba->getHost($row1['host_id']);

      $id_ps=array();
      $res2=mysql_query("SELECT DISTINCT `pseudo_id` FROM gls_contacts WHERE user_id=$userid AND host_id=".$row1['host_id']);
      while ($row2=mysql_fetch_assoc($res2)) {
        $id_ps[]=$row2['pseudo_id'];
      }

      if (count($id_ps)>0){
        $output=$this->remoteCall($host['id'],"getcontactlist",array(serialize($id_ps)));

        $res=unserialize($output[1]);
        foreach ($res as $row1) {
          $row1['host_id']=$host['id'];
          $row1['host_name']=$host['name'];
          $sql="SELECT * FROM gls_contacts WHERE user_id=".$userid." AND pseudo_id=".$row1['id']." AND host_id=".$host['id'];
          $t=$this->sql_getOne($sql);
          $row1['mycomment']=$t['mycomment'];

          array_push($myarr,$row1);
        }
      }
    }
    return $myarr;
  }

  function forum2ndname($fid,$uid) {
    $fid=intval($fid);
    $uid=intval($uid);
    $res1=mysql_query("select customname from gls_customnames where (forum_id=$fid) && (user_id=$uid);");
    if (mysql_num_rows($res1)==1) {
      $row1=mysql_fetch_array($res1);
      return $row1['customname'];
    } else {
      $row1=mysql_fetch_array(mysql_query("select name from gls_forums where id=$fid;"));
      return $row1['name'];
    }
  }

  function getEmailList($userid) {
    $userid=intval($userid);
    $myarr=array();
    //      
    $query="SELECT * FROM gls_email WHERE user_id=".$userid;
    $res1=mysql_query($query);
    while ($row1=@mysql_fetch_assoc($res1)) {
      array_push($myarr,$row1);
    }
    return $myarr;
  }

  function getpseudoidbyname($name) {
        $userinfo = explode ("@", $name) ;
        if (isset ($userinfo[1]))
                $host = $this->glsDba->gethostbyname ($userinfo[1]) ;
        else $host = 0 ;
      $output = $this->remoteCall ($host['id'], "pseudoexists", array ($userinfo[0])) ;
      if (($output=='') || $output[1]==0){
            $row1=mysql_fetch_array(mysql_query("SELECT id FROM gls_pseudos WHERE name='".mysql_escape_string($name)."'"));
            return $row1['id'];
        }
        else
        {
                return array (0 => $output[1], 1 => $host['id']) ;
        }
  }

  function getuseridbyname($name) {
    if($row1=mysql_fetch_array(mysql_query("select id from gls_users where login='".mysql_escape_string($name)."'"))) {
      return $row1['id'];
    } else {
      return -1;
    }
  }

        function getuseridbypseudoid ($id)
        {
            $row1=mysql_fetch_array(mysql_query("SELECT user_id FROM gls_pseudos WHERE id=$id"));
            return $row1['user_id'];
        }

  function goodanswer($id,$secra) {
    $id=intval($id);
    $secra=mysql_escape_string($secra);
    $row1=mysql_fetch_array(mysql_query("select secr_a from gls_users where id=$id;"));
    if (str_replace(' ','',strtolower($secra))==str_replace(' ','',strtolower($row1['secr_a']))) {return true;} else {return false;}
  }

  function getsecretquestion($id) {
    $row1=mysql_fetch_array(mysql_query("select secr_q from gls_users where id=".intval($id)));
    return $row1['secr_q'];
  }

  function getfulluserinfo($id) {
    return mysql_fetch_array(mysql_query("select * from gls_users where id=".intval($id)));
  }

  function addContact($userId,$pseudo, $host){
    $host=intval($host);
    $userId=intval($userId);
    $pseudo=mysql_escape_string($pseudo);

      if ($host==0)
      {

      if ($this->mysql_count('gls_pseudos',"name='$pseudo'")==0){
        return false; //     
        }

      $query="REPLACE gls_contacts SET `user_id`=$userId, `pseudo_id`='".mysql_escape_string($this->getpseudoidbyname($pseudo))."', `host_id`=$host";
      mysql_query($query);
      return true;
    }else{
      $output=$this->remoteCall($host,"pseudoexists",array($pseudo)); //      . 0 -  ,   - id 
      if ($output[1]==0){
        return false;
      }else{
        $query="REPLACE gls_contacts SET `user_id`='".mysql_escape_string($userId)."', `pseudo_id`='".mysql_escape_string($output[1])."', `host_id`=$host";
        mysql_query($query);
        return true;
      }
    }
  }

  function settranslation4user($uid,$id) {
    $uid=intval($uid);
    $id=intval($id);
    mysql_query("UPDATE gls_users SET trans_id=$id where id=$uid;");
    //    $row2=mysql_fetch_array(mysql_query("select value from forums_lang_keys where (`key_key`=129) && (trans_id=$id);"));
    //    mysql_query("update forums_folders set name='".$row2['value']."' where (user_id=$uid) && (boxtype='PF');");
    //    $row2=mysql_fetch_array(mysql_query("select value from forums_lang_keys where (`key_key`=146) && (trans_id=$id);"));
    //    mysql_query("update forums_folders set name='".$row2['value']."' where (user_id=$uid) && (boxtype='MB');");
  }

  function canadd($uid,$pid) {
    $uid=intval($uid);
    $pid=intval($pid);
    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_contacts WHERE (user_id=$uid) && (pseudo_id=$pid);"));
    if ($row1['count(*)']==0) {
      $row2=mysql_fetch_array(mysql_query("SELECT user_id FROM gls_pseudos WHERE id=$pid;"));
      if ($row2['user_id']==$uid) {return 'N';} else {return 'Y';}
    } else {return 'N';}
  }

  function getprivforumslistofpseudo($pid, $uid, $host) {
    $uid=intval($uid);
    $pid=intval($pid);
    $myarr=array();
    if ($host!=0) return $myarr;
    $query="SELECT DISTINCT t1.name,t1.id FROM gls_forums t1,gls_threads t2,gls_messages t3,gls_pseudos t5
    WHERE t3.pseudo_id=$pid AND t3.thread_id=t2.id AND t2.forum_id=t1.id";
    $res1=mysql_query($query);

    while ($row1=mysql_fetch_array($res1)) {
      array_push($myarr,$row1);
    }
    return $myarr;
  }

  function getdbstatus() {
    $row1=mysql_fetch_array(mysql_query("select count(*) from gls_users;"));
    $row2=mysql_fetch_array(mysql_query("select count(*) from gls_pseudos;"));
    $res3=mysql_query("show table status;");
    $total=0;
    while ($row3=mysql_fetch_array($res3)) {
      $total=$total+$row3['Data_length'];
    }
    return array('users'=>$row1['count(*)'],'pseudos'=>$row2['count(*)'],'diskspace'=>$total);
  }

  function addEmail($userId,$email, $comment){
    $userId=intval($userId);

    if (!eregi('^[0-9a-z_\\.]+@[0-9a-z\\._-]+(\\.[a-z]{2,4})*$',$email)){
      return false;
    }
      $res=mysql_query("SELECT COUNT(*) FROM gls_contacts WHERE user_id=$userId AND email='$email'");
      $res=mysql_fetch_row($res);

      if ($res[0]>0) return false;

        $str = "INSERT INTO gls_contacts VALUES ($userId, 0, 0, '$comment', '$email', NULL)" ;

      mysql_query($str);
      return true;

  }

  function delContact($userId, $pseudoId, $host){
    $host=intval($host);
    $query="DELETE FROM gls_contacts WHERE `user_id`='".intval($userId)."' AND `pseudo_id`='".intval($pseudoId)."' AND `host_id`=$host";
    mysql_query($query);
    return true;
  }

  function delEmail($userId, $id){
    $query="DELETE FROM gls_email WHERE `user_id`='".intval($userId)."' AND `id`='".intval($id)."' LIMIT 1";
    mysql_query($query);
    return true;
  }

  function deleteinvite($host,$pseudoid,$forumid){ // Ivan Maroz
    $pseudoid=(int)($pseudoid);
    $forumid=(int)($forumid);
    $host=mysql_escape_string($host);

    if ($host==='m'){
      $query="DELETE FROM `gls_accesses_email` WHERE `email_id`=$pseudoid AND `forum_id`=$forumid LIMIT 1";
    }else{
      $query="DELETE FROM `gls_accesses` WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND `host_id`=$host LIMIT 1";
    }
    mysql_query($query);
    return true;
  }

  function invitebyemail($email_id,$perm,$forumid,$bypid,$viewinv, $subject){ // Ivan Maroz
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $perm=strtolower($perm);
    if (!isset($a[$perm])){
      $perm='r'; //     ,     
    }
    $level=$a['r'];//        

    $email_id=(int)($email_id);
    $bypid=(int)($bypid);
    $forumid=(int)($forumid);
    $viewinv=strtoupper($viewinv);

    if (($viewinv!='N')and($viewinv!='Y')){
      $viewinv='N';
    }

    $mail=$this->sql_getOne("SELECT * FROM `gls_contacts` WHERE id=".$email_id." AND user_id=".$_SESSION['finf']['userid']);
    if (!$mail){
      return false;
    }

    if ($this->mysql_count('gls_forums', "`pseudo_id`=$bypid AND id=$forumid")!=0){
      $level=$a['a']; //     
    }else{
      $query="SELECT * FROM `gls_accesses` WHERE `forum_id`=$forumid AND `pseudo_id`=$bypid AND host_id=0";
      $result=mysql_query($query);
      if ($row=mysql_fetch_assoc($result)){
        $level=$a[$row['rights']]; //     
      }
    }

    if ($a[$perm]>$level){ //     ,  
      $perm=array_search($level,$a); //  ,  $level
    }

    $email = $mail['email'] ;
    $comment = $mail['mycomment'] ;


    $query = " SELECT * FROM gls_email WHERE email = '$email' " ;
    $data = $this->sql_getOne($query) ;
    if (!$data) {
      $query = " INSERT INTO gls_email SET user_id={$_SESSION['finf']['userid']}, email='$email', comment='$comment' " ;
      mysql_query ($query) ;
      $email_id = mysql_insert_id();
    }
    else {
      $email_id = $data['id'] ;
    }


    $query="SELECT * FROM gls_accesses_email
      WHERE `email_id`=$email_id AND `forum_id`=$forumid";
    $data=$this->sql_getOne($query);

    $rnd=_newRandomString();

    if ($data){
      $query="UPDATE `gls_accesses_email` SET `rights`='$perm', `rights_deny`='$perm', `key`='".mysql_escape_string($rnd)."' WHERE `forum_id`=$forumid AND email_id=$email_id";
    }else{
      $query="INSERT INTO `gls_accesses_email` SET `email_id`=$email_id, `key`='".mysql_escape_string($rnd)."', `pseudo_who_invited`=$bypid, `rights`='$perm', `rights_deny`='$perm', `forum_id`=$forumid, `create_date`=NOW(), `view_inv`='".mysql_escape_string($viewinv)."'";
    }
    mysql_query($query);


    $invtxt=file_get_contents('inv.txt');
    $url='http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?action=mailinv&key='.$rnd;

    $from=$this->getpseudodata($bypid,0);
    $headers= "From: ".$from['name']."@".$_SERVER['HTTP_HOST']."\r\n";


    $query="SELECT * FROM `gls_forums` WHERE id=".$forumid;
    $res=$this->sql_getOne($query);


    $query="SELECT * FROM `gls_pseudos` WHERE `id`=".$bypid;
    $r=$this->sql_getOne($query);
    $pseudo=$r['name'];


    //    print "<pre>";
    //    print_r($forumname);
    //    print "</pre>";

    $invtxt=ereg_replace('{INV_KEY}',    $url,         $invtxt);
    $invtxt=ereg_replace('{INV_AUTHOR}', $pseudo,      $invtxt);
    $invtxt=ereg_replace('{INV_FORUM}',  $res['name'], $invtxt);

    //  (Pavel Pipkin)
    if(strlen($subject) < 1 ) $subject = 'Invitation to "'.$res['name'].'"';

    mail($mail['email'], $subject, $invtxt, $headers);

  }

// send invite to the $email_id on the forum from the remote user.
 function invitebyemailremote($email_id,$perm,$forumid,$bypid,$viewinv, $subject){ // pavel pipkin
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $perm=strtolower($perm);
    if (!isset($a[$perm])){
      $perm='r'; //     ,     
    }
    $level=$a['r'];//        

    $email_id=(int)($email_id);
    $bypid=(int)($bypid);
    $forumid=(int)($forumid);
    $viewinv=strtoupper($viewinv);

    if (($viewinv!='N')and($viewinv!='Y')){
      $viewinv='N';
    }

    $output=$this->remoteCall($_SESSION['rinf']['host_id'], "getuseridbypseudoid", array($_SESSION['rinf']['user']['id']));
    $user_id = $output[1];

    $output1=$this->remoteCall($_SESSION['rinf']['host_id'], "getcontacts", array($user_id));
    $contacts = unserialize($output1[1]);

   foreach($contacts as $contact)
   {
      if($email_id == $contact['emailid'])
      {
              $mail['email'] = $contact['email'];
              $mail['mycomment'] = $contact['mycomment'];
      }
   }


    $query="SELECT * FROM `gls_accesses` WHERE `forum_id`=$forumid AND `pseudo_id`=$bypid AND host_id=0";
      $result=mysql_query($query);
      if ($row=mysql_fetch_assoc($result)){
        $level=$a[$row['rights']]; //     
      }


    if ($a[$perm]>$level){ //     ,  
      $perm=array_search($level,$a); //  ,  $level
    }

    $email = $mail['email'] ;
    $comment = $mail['mycomment'] ;

    $query = " SELECT * FROM gls_email WHERE email = '$email' " ;
    $data = $this->sql_getOne($query) ;
    if (!$data) {
      $query = " INSERT INTO gls_email SET user_id={$_SESSION['finf']['userid']}, email='$email', comment='$comment' " ;
      mysql_query ($query) ;
      $email_id = mysql_insert_id();
    }
    else {
      $email_id = $data['id'] ;
    }


    $query="SELECT * FROM gls_accesses_email
      WHERE `email_id`=$email_id AND `forum_id`=$forumid";
    $data=$this->sql_getOne($query);

    $rnd=_newRandomString();

    if ($data){
      $query="UPDATE `gls_accesses_email` SET `rights`='$perm', `rights_deny`='$perm', `key`='".mysql_escape_string($rnd)."' WHERE `forum_id`=$forumid AND email_id=$email_id";
    }else{
      $query="INSERT INTO `gls_accesses_email` SET `email_id`=$email_id, `key`='".mysql_escape_string($rnd)."', `pseudo_who_invited`=$bypid, `rights`='$perm', `rights_deny`='$perm', `forum_id`=$forumid, `create_date`=NOW(), `view_inv`='".mysql_escape_string($viewinv)."'";
    }
    mysql_query($query);

$invtxt=file_get_contents('inv.txt');
    $url='http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?action=mailinv&key='.$rnd;


    foreach($_SESSION['rinf']['pseudos'] as $v)
    {
       if($bypid == $v['id']) $pseudo=$v['name'];
    }


   $res=$this->glsDba->getHosts();
   foreach($res as $v)
   {
      if($v['id'] == $_SESSION['rinf']['host_id']) $host = $v['name'];
   }

   $headers= "From: ".$pseudo."@".$host."\r\n";

    $query="SELECT * FROM `gls_forums` WHERE id=".$forumid;
    $res=$this->sql_getOne($query);


    $invtxt=ereg_replace('{INV_KEY}',    $url,         $invtxt);
    $invtxt=ereg_replace('{INV_AUTHOR}', $pseudo,      $invtxt);
    $invtxt=ereg_replace('{INV_FORUM}',  $res['name'], $invtxt);

    //  (Pavel Pipkin)
    if(strlen($subject) < 1 ) $subject = 'Invitation to "'.$res['name'].'"';

 mail($mail['email'], $subject, $invtxt, $headers);

  }



  function sendMessageEmail($mess_id, $host=0, $exludemail=''){

     $mess_id=intval($mess_id);
    $host=intval($host);

    $thread_id=$this->message2thread($mess_id);
    $forum_id=$this->thread2forum($thread_id);

    $query="SELECT DISTINCT t1.*, t2.key FROM `gls_email` t1, `gls_accesses_email` t2 WHERE t2.forum_id=".$forum_id." AND (t2.email_id=t1.id)";
    $emails=$this->sql_getAll($query);
    if (count($emails)>0){
      $query="SELECT * FROM `gls_messages` WHERE `id`=".$mess_id;
      $message=$this->sql_getOne($query);


      $pseudo=$this->getpseudodata($message['pseudo_id'],$host);
      if ($host==0){
        if ($exludemail){
          $headers= "From: ".$exludemail."\r\n";
        }else{
          $headers= "From: ".$pseudo['name']."@".$_SERVER['HTTP_HOST']."\r\n";
        }
      }else{
        $host=$this->glsDba->getHost($host);
        $from=preg_replace('!http://!i','', $host['address_base']);
        $from=preg_replace('!/.*!i','',     $from);
        $headers= "From: ".$pseudo['name']."@".$from."\r\n";
      }

      $mess_txt=file_get_contents('email_mess.txt');

      if ($exludemail){
        $mess_txt=ereg_replace('{FROM}',  $exludemail,    $mess_txt);
      }else{
        $mess_txt=ereg_replace('{FROM}',  $pseudo['name'],    $mess_txt);
      }
      $mess_txt=ereg_replace('{TOPIC}', $message['header'], $mess_txt);
      $mess_txt=ereg_replace('{BODY}',  $message['body'],   $mess_txt);

      //      [forum name] subject of message

      $forumInfo=$this->foruminfo($forum_id, 0);
      $subject="[".$forumInfo['name']."] ".$message['header'];

      $sent=false;
      foreach ($emails as $mail) {
        //        print_r($mail);
        if ($mail['email']!=$exludemail){
          $url='http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?action=mailinv&key='.$mail['key'];
          
      $headers .= "Content-type: text/plain; charset=utf-8\r\n";    
          mail($mail['email'],$subject, $mess_txt."\n\n".$url, $headers);
          $sent=true;
        }
      }

      return $sent;
    }else{
      return false;
    }
  }

  function set_inv($pseudo,$host,$forumid,$inv){
    if (($inv=='y')or($inv=='Y')){
      $inv='Y';
    }else{
      $inv='N';
    }
    $pseudo=intval($pseudo);
    $host=mysql_escape_string($host);
    $forumid=intval($forumid);

    if ($host==='m'){
      $query="UPDATE `gls_accesses_email` SET `view_inv`='".$inv."' WHERE `email_id`=$pseudo AND `forum_id`=$forumid";
    }else{
      $query="UPDATE `gls_accesses` SET `view_inv`='".$inv."' WHERE `pseudo_id`=$pseudo AND `host_id`=$host AND `forum_id`=$forumid";
    }
    mysql_query($query);
  }

  function invitebyid($host,$pseudoid,$perm,$forumid,$bypid,$viewinv){ // Ivan Maroz

    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $perm=strtolower($perm);
    if (!isset($a[$perm])){
      $perm='r'; //     ,     
    }
    $level=$a['r'];//        


    $pseudoid=(int)($pseudoid);
    $bypid=(int)($bypid);
    $forumid=(int)($forumid);
    $host=(int)($host);
    $viewinv=strtoupper($viewinv);

    if ($viewinv=='false') $viewinv='N' ;
    if ($viewinv=='true') $viewinv='Y' ;

    if (($viewinv!='true')and($viewinv!='false')){
      $viewinv='N';
    }

    if ($host==0){ //  
      if ($this->mysql_count('gls_forums', "`pseudo_id`=$bypid AND id=$forumid")!=0){
        $level=$a['a']; //     
      }else{
        $query="SELECT * FROM `gls_accesses` WHERE `forum_id`=$forumid AND `pseudo_id`=$bypid AND host_id=0";
        $result=mysql_query($query);
        if ($row=mysql_fetch_assoc($result)){
          $level=$a[$row['rights']]; //     
        }
      }

      if ($a[$perm]>$level){ //     ,  
        $perm=array_search($level,$a); //  ,  $level
      }

      $query="SELECT * FROM gls_accesses
      WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND host_id=0";
      $data=$this->sql_getOne($query);

      if ($data){
        if ($a[$data['rights']]>$a[$perm]){
          $perm=$data['rights'];
        }
        $query="UPDATE `gls_accesses` SET `rights`='$perm', `pseudo_who_invited`=$bypid WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND host_id=0";

      }else{
        $query="INSERT INTO `gls_accesses` SET `pseudo_id`=$pseudoid, `pseudo_who_invited`=$bypid, `rights`='$perm', `rights_deny`='a', `forum_id`=$forumid, `create_date`=NOW(), `view_inv`='".mysql_escape_string($viewinv)."', host_id=0";
                $userid = $this->getuseridbypseudoid ($pseudoid);
                $where = $this->getMB ($userid) ;
                $query2 = "INSERT INTO gls_forums2folders VALUES ($forumid, $where)" ;

                $this->sql_query ($query2) ;
      }

      mysql_query($query);

    }else{
      if($this->glsDba->getHost($host)){  // ,    

        if ($this->mysql_count('gls_forums', "`pseudo_id`=$bypid AND id=$forumid")!=0){
          $level=$a['a']; //     
        }else{
          $query="SELECT * FROM `gls_accesses` WHERE `forum_id`=$forumid AND `pseudo_id`=$bypid AND host_id=0";
          $result=mysql_query($query);
          if ($row=mysql_fetch_assoc($result)){
            $level=$a[$row['rights']]; //     
          }
        }


        if ($a[$perm]>$level){ //     ,  
          $perm=array_search($level,$a); //  ,  $level
        }

        $output=$this->remoteCall($host, "getcontactlist", array(serialize(array($pseudoid)))); //      

        $contact=unserialize($output[1]);
        if (count($contact)==0){ //      
          return false;
        }

        $query="SELECT * FROM gls_accesses
      WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND host_id=$host";
        $data=$this->sql_getOne($query);

        if ($data){
          if ($a[$data['rights']]>$a[$perm]){
            $perm=$data['rights'];
          }
          $query="UPDATE `gls_accesses` SET `rights`='$perm' WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND host_id=$host";
        }else{
          $query="INSERT INTO `gls_accesses` SET `pseudo_id`=$pseudoid, `pseudo_who_invited`=$bypid, `rights`='$perm', `rights_deny`='a', `forum_id`=$forumid, `create_date`=NOW(), `view_inv`='".mysql_escape_string($viewinv)."', host_id=$host";
        }

        mysql_query($query);
        return $contact;

      }else{
        return false;
      }
    }

  }

  function invitebyiddeny($host,$pseudoid,$perm,$forumid,$bypid,$user_id){ // Ivan Maroz
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $perm=strtolower($perm);
    if (!isset($a[$perm])){
      $perm='r'; //     ,     
    }
    $level=$a['r'];//        


    $pseudoid=(int)($pseudoid);
    $bypid=(int)($bypid);
    $forumid=(int)($forumid);
    $host=mysql_escape_string($host);
    $user_id=intval($user_id);

    $level=$this->getrights($forumid, $user_id);

    if ($level<ACCESS_ADMIN){
      return false;
    }

    if ($host==='m'){
      $query="UPDATE `gls_accesses_email` SET `rights_deny`='$perm' WHERE `email_id`=$pseudoid AND `forum_id`=$forumid";
    }else{
      $query="UPDATE `gls_accesses` SET `rights_deny`='$perm' WHERE `pseudo_id`=$pseudoid AND `forum_id`=$forumid AND host_id=$host";
    }
    mysql_query($query);

    return true;
  }

  /**
 *   
 *       .       WHERE
 **/

  function getPseudosName(&$pseudo){
    $query="SELECT * FROM `gls_pseudos` ORDER BY `name`";
    $result=@mysql_query($query);
    while ($row=mysql_fetch_assoc($result)) {
      $pseudo[0][$row['id']]=$row['name'];
    }
    return true;
  }

  /**
 *     
 **/
  function getrightslist($forumid, $user_id, &$rights, &$pseudo){
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $rights=array();
    //      
    $query="SELECT * FROM gls_accesses WHERE forum_id='".intval($forumid)."' AND host_id=0";
    $result=mysql_query($query);//      

    while ($row=@mysql_fetch_assoc($result)) {
      $row['host_id']=0;
      if ($a[$row['rights']]<$a[$row['rights_deny']]){
        $row['level']=$row['rights'];
      }else{
        $row['level']=$row['rights_deny'];
      }
      $rights[]=$row;
    }


    $query="SELECT * FROM gls_accesses WHERE forum_id='".intval($forumid)."' AND host_id<>0 ORDER BY host_id";
    $result=mysql_query($query);//      
    $host=-1;
    $uid=array(); //  id    
    while ($row=@mysql_fetch_assoc($result)) {
      if ($a[$row['rights']]<$a[$row['rights_deny']]){
        $row['level']=$row['rights'];
      }else{
        $row['level']=$row['rights_deny'];
      }
      $rights[]=$row;

      if (($host!=$row['host_id'])and($host!=-1)){
        $ruid=array();
        foreach ($uid as $k => $v) {
          $ruid[]=$k;
        }
        $output=$this->remoteCall($host, "getcontactlist", array(serialize($ruid)));
        $contact=unserialize($output[1]);
        foreach ($contact as $k => $v) {
          $v['name']['host_name']=$host['name'];
          $pseudo[$host][$v['id']]=$v['name'];
          //          $pseudo[$host][$v['host_name']]=$host['name'];
          //        $row1['host_name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['host_name'];
        }
        $uid=array();
      }

      $host=$row['host_id'];
      $uid[$row['pseudo_id']]=1;
    }

    if ($host!=-1){
      $ruid=array();
      foreach ($uid as $k => $v) {
        $ruid[]=$k;
      }

      $output=$this->remoteCall($host, "getcontactlist", array(serialize($ruid)));
      $contact=unserialize($output[1]);

      foreach ($contact as $k => $v) {
        $pseudo[$host][$v['id']]=$v['name'];
      }
    }

    //     e-mail
    $query="SELECT * FROM gls_accesses_email WHERE forum_id='".intval($forumid)."'";
    $result=mysql_query($query);//     e-mail
    while ($row=@mysql_fetch_assoc($result)) {
      $row['host_id']='m';
      if ($a[$row['rights']]<$a[$row['rights_deny']]){
        $row['level']=$row['rights'];
      }else{
        $row['level']=$row['rights_deny'];
      }
      $rights[]=$row;
    }

    return true;
  }

  function changepseudodata($userid,$pseuodid,$comm1, $comm2){
    $query="UPDATE `gls_pseudos` SET
      comment='$comm1',
      comment2='$comm2'
      WHERE `id`=".intval($pseuodid)." AND `user_id`=".intval($userid);
    mysql_query($query);
    return true;
  }


  function getanonlythreadindex($forumid)
  {
    $res1=mysql_query("select id from gls_threads where forum_id=".intval($forumid));
    $row1=mysql_fetch_array($res1);
    return $row1['id'];
  }

  function getpseudodata($id, $hostid) {
        global $gls_cfg;
    $id=(int)$id;
    $hostid=(int)$hostid;

    if ($hostid==0){
      $ps=mysql_fetch_assoc(mysql_query ("SELECT * FROM gls_pseudos WHERE id=$id;"));
      $ps['host_id']=0;
      $ps['host_name']=$gls_cfg['ourname'];
    }else{
      $output=$this->remoteCall($hostid, "getcontactlist", array(serialize(array($id)))); //      

      $contact=unserialize($output[1]);
      if (count($contact)==0){ //      
        return false;
      }
      $ps=$contact[0];

      $host=$this->glsDba->getHost($hostid);
      $ps['host_id']=$host['id'];
      $ps['host_name']=$host['name'];
      $ps['comment'] = str_replace ('<', '&lt;', $ps['comment']) ;
      $ps['comment2'] = str_replace ('>', '&gt;', $ps['comment2']) ;
    }
    return $ps;
  }

  function getrootfolder($folderid) {
    $id=intval($folderid);
    $row1=mysql_fetch_array(mysql_query("select boxtype,parent_id from forums_folders where id='$id';"));
    while ($row1['boxtype']=='child') {
      $id=$row1['parent_id'];
      $row1=mysql_fetch_array(mysql_query("select boxtype,parent_id from forums_folders where id='$id';"));
    }
    return $id;
  }

  function folderispub($folderid) {
    $query="SELECT * FROM `gls_folders` WHERE `id`=".intval($folderid);
    $row=mysql_fetch_assoc(mysql_query($query));
    if ($row['type']=='PublicForum'){
      return true;
    }else{
      return false;
    }
  }

  function folderType($folderid) {
    $query="SELECT * FROM `gls_folders` WHERE `id`=".intval($folderid);
    $row=mysql_fetch_assoc(mysql_query($query));
    return $row['type'];
  }

  //       . ,    ,    
  function createforum($userid,$newname,$pid,$folderid,$com,$com2,$access='private') {
    $a=$this->folderType($folderid);

    $pid=(int)$pid;
    $userid=(int)$userid;
    $folderid=(int)$folderid;
//    $newname=mysql_escape_string($newname);
//    $com=mysql_escape_string($com);
//    $com2=mysql_escape_string($com2);


    if (($access!='semipublic')and($access!='public')and($access!='private')){
      $access='semipublic';
    }
    if ((($access=='semipublic')or($access=='public'))and($a!='PublicForum')){
      $query="SELECT id FROM `gls_folders` WHERE user_id=".$userid." AND `type`='PublicForum'";
      $row=mysql_fetch_assoc(mysql_query($query));
      $folderid=$row['id'];
    }
    /*    if ($a=='MainBox'){
    $access='private';
    }
    */
    $query="INSERT INTO `gls_forums` SET user_id=$userid, pseudo_id=$pid, `name`='$newname', `folder_id`=$folderid, `comment`='$com', `comment2`='$com2', `access`='$access'";
    mysql_query($query);
    $newid=mysql_insert_id();
        $query = "INSERT INTO gls_forums2folders VALUES ($newid, $folderid)" ;
        mysql_query ($query) ;
    mysql_query("insert into gls_threads values(0,'$newname',$newid,'".date('Y-m-d')."','N');");

// yarashevich
// add guest to edit list of public forum

    if ($access=='public')
    {
        $query = "INSERT INTO gls_accesses VALUES (1, $pid, 0, $newid, 'w', 'a', NOW(), 'N', 0)" ;
        mysql_query ($query) ;
    }


    return $newid;
  }

  function myPseudos($userid){
    $query="SELECT * FROM gls_pseudos WHERE `user_id`=".intval($userid);
    return  $this->sql_getAll($query);
  }

  //      
  function forumMembers($forumid){

    //    $query="SELECT DISTINCT t1.user_id, t1.pseudo_id, t1.host_id
    //FROM `gls_messages` t1, gls_threads t2, gls_accesses t3, gls_forums t4
    //WHERE t2.forum_id=".intval($forumid)." AND t1.thread_id=t2.id AND t3.forum_id=t4.id AND (t3.rights='a' AND t3.pseudo_id=t1.pseudo_id)";

    $query="SELECT DISTINCT t1.user_id, t1.pseudo_id, t1.host_id
      FROM `gls_messages` t1, gls_users t2, gls_accesses t3
      WHERE t1.forum_id=".intval($forumid)." AND t1.user_id=t2.id AND /*t2.admin='Y' AND*/ t1.host_id=0";

    $data=$this->sql_getAll($query);
    return $data;
  }

  function getCustomName($forum_id, $userid, $default, $host=0){
    $sql="SELECT * FROM gls_customnames WHERE forum_id=".intval($forum_id)." AND user_id=".intval($userid)." AND host_id=".intval($host);
    $res=$this->sql_getOne($sql);
	if (isset($res['customname']))
	{
	     $res['customname'] = str_replace ('<', '&lt;', $res['customname']) ;
	     $res['customname'] = str_replace ('>', '&gt;', $res['customname']) ;
	}
    return (isset($res['customname']))? $res['customname'] : $default;
  }

  function getCountNewMessThread($threadid, $userid){
    $threadid=intval($threadid);
    $userid=intval($userid);

    $sql="SELECT * FROM gls_threads_lastvisits WHERE user_id=$userid AND thread_id=$threadid";
    $last=$this->sql_getOne($sql);
    if ($last){
      $where="thread_id=$threadid AND created>'".$last['when']."' AND valid='Y'";
    }else{
      $where="thread_id=$threadid AND valid='Y'";
    }

    return $this->mysql_count('gls_messages', $where);
  }

  function getCountNewMessForum($forumid, $userid){
    $forumid=intval($forumid);
    $userid=intval($userid);

    $sql="SELECT * FROM `gls_threads` WHERE forum_id=".$forumid;
    $threads=$this->sql_getAll($sql);
    //        print_r($threads);

    $count=0;
    foreach ($threads as $thread) {
      $count+=$this->getCountNewMessThread($thread['id'],$userid);
    }
    //    print "$forumid - $count<br>";
    return $count;
  }

  function isOwner($forumid, $userid){
    return ($this->mysql_count('gls_forums', "id=".intval($forumid)." AND user_id=".intval($userid))>0)?'Y':'N';
  }

  function getforumslist($userid, $folderid){
    $userid=intval($userid);
    $folderid=intval($folderid);

    $query="SELECT * FROM gls_folders WHERE id=$folderid AND user_id=$userid";
    $data=$this->sql_getOne($query);
    $output=array();
    if ($data['type']=='MainBox'){ //   ,    "" 
      $ids=array();
      $ps=$this->myPseudos($userid);
      foreach ($ps as $v) {
        $ids[]=$v['id'];
      }
      $forumids=array();

      $query="SELECT * FROM gls_forums f, gls_forums2folders ff WHERE f.id=ff.forum_id AND ff.folder_id=$folderid ";
      $result=mysql_query($query);
      while ($row = mysql_fetch_assoc($result)) {
//        if (($row['access']!='semipublic')and($row['access']!='public'))
        {
          $m=$this->forumMembers($row['id']);
          $row['members']=$m;
              $row['name'] = str_replace ('<', '&lt;', $row['name']) ;
            $row['name'] = str_replace ('>', '&gt;', $row['name']) ;
          $row['realname']=$row['name'];
          $row['name']=$this->getCustomName($row['id'],$userid,$row['name']);
          $row['new']=$this->getCountNewMessForum($row['id'], $userid);
          $row['owner']=$this->isOwner($row['id'], $userid);
          $output[]=$row;
          $forumids[$row['id']]=1;
        }
      }
/*
      $query="SELECT DISTINCT t1.* FROM `gls_forums` t1, gls_accesses t2, gls_pseudos t3
      WHERE
      (t1.id=t2.forum_id AND t2.pseudo_id=t3.id AND t3.user_id=$userid AND host_id=0)
      ";
      $result=mysql_query($query);
      while ($row = mysql_fetch_assoc($result)) {
        if (($row['access']!='semipublic')and($row['access']!='public')and(!isset($forumids[$row['id']]))){
          $row['new']=$this->getCountNewMessForum($row['id'],$userid);
          $m=$this->forumMembers($row['id']);
          $row['members']=$m;
          $row['realname']=$row['name'];
          $row['name']=$this->getCustomName($row['id'],$userid,$row['name']);
          $row['owner']=$this->isOwner($row['id'], $userid);
          $output[]=$row;
          $forumids[$row['id']]=1;
        }
      }
      foreach ($output as $v)
      echo serialize($v)."<BR>";
*/
      $query="SELECT DISTINCT t1.* FROM `gls_forums` t1, gls_subscribtions t2 WHERE (t2.forum_id=t1.id AND t2.user_id=$userid)";
      $result=mysql_query($query) or print mysql_error();
      while ($row = @mysql_fetch_assoc($result)) {
        if (!isset($forumids[$row['id']])){
          $row['new']=$this->getCountNewMessForum($row['id'],$userid);
          if ($row['new']!=0){
            $m=$this->forumMembers($row['id']);
            $row['members']=$m;
          $row['name'] = str_replace ('<', '&lt;', $row['name']) ;
          $row['name'] = str_replace ('>', '&gt;', $row['name']) ;
            $row['realname']=$row['name'];
            $row['name']=$this->getCustomName($row['id'],$userid,$row['name']);
            $row['owner']=$this->isOwner($row['id'], $userid);
            $output[]=$row;
            $forumids[$row['id']]=1;
          }
        }
      }

      //      print $query;
    }elseif($data['type']=='PublicForum'){ //    
      $query="SELECT * FROM `gls_forums` WHERE `access`='semipublic' OR `access`='public'";
      $result=mysql_query($query);
      while ($row = mysql_fetch_assoc($result)) {
        $m=$this->forumMembers($row['id']);
        $row['members']=$m;
          $row['name'] = str_replace ('<', '&lt;', $row['name']) ;
          $row['name'] = str_replace ('>', '&gt;', $row['name']) ;
        $row['realname']=$row['name'];
        $row['name']=$this->getCustomName($row['id'],$userid,$row['name']);
        $row['new']=$this->getCountNewMessForum($row['id'],$userid);
        $row['owner']=$this->isOwner($row['id'], $userid);
        $output[]=$row;
        }
    }else{
      $query="SELECT * FROM gls_forums f, gls_forums2folders ff WHERE f.id=ff.forum_id AND ff.folder_id=$folderid ";
      $result=mysql_query($query);
      while ($row = mysql_fetch_assoc($result)) {
         $m=$this->forumMembers($row['id']);
          $row['members']=$m;
          $row['name'] = str_replace ('<', '&lt;', $row['name']) ;
          $row['name'] = str_replace ('>', '&gt;', $row['name']) ;
          $row['realname']=$row['name'];
          $row['name']=$this->getCustomName($row['id'],$userid,$row['name']);
          $row['new']=$this->getCountNewMessForum($row['id'],$userid);
          $row['owner']=$this->isOwner($row['id'], $userid);
          $output[]=$row;
        }
    }

    if ($data['type']=='MainBox'){
      $hosts=$this->getHosts();
      foreach ($hosts as $host) {
        $x=$this->remoteCall($host['id'],'forumlist',array(serialize($ids)));
        $remoteForum=@unserialize($x[1]);
        if (is_array($remoteForum)){
          foreach ($remoteForum as $v) {
          $row['name'] = str_replace ('<', '&lt;', $row['name']) ;
          $row['name'] = str_replace ('>', '&gt;', $row['name']) ;
            $v['realname']=$v['name'];
            $v['name']=$this->getCustomName($v['id'],$userid,$v['name'], $host['id']);
            $v['host']=$host['id'];
            $v['hostname']=$host['name'];
            $output[]=$v;
          }
        }
      }
    }


    return $output;
  }

  function getAdmins(){
    $sql="SELECT id, login FROM `gls_users` WHERE admin='Y' ORDER BY login";
    return $this->sql_getAll($sql);
  }

        function getForumAdmins ($id)
        {
                $admins = $this->getAdmins();
                $right = $this->getrights ($id, $_SESSION['finf']['userid']) ;
                $sql = "SELECT gu.id, gu.login FROM gls_users gu, gls_pseudos gp, gls_forums gf, gls_accesses ga WHERE ga.forum_id=gf.id AND ga.pseudo_id=gp.id ".
                        " AND gp.user_id=gu.id AND ga.forum_id=$id" ;
                $sql = mysql_query ($sql) ;
                while ($sql2 = mysql_fetch_array($sql))
                {
                        $admins[] = array ('id' => $sql2['id'], 'login' => $sql2['login']) ;
                }
                return $admins ;
        }

  function getRemoteForumsList($pseudosStr, $hostid){
    $pseudosStr=mysql_escape_string($pseudosStr);
    $hostid=intval($hostid);

    $output=array();

    $query="SELECT DISTINCT t1.*, t3.name AS pseudo FROM `gls_forums` t1, gls_accesses t2, gls_pseudos t3
    WHERE (`access`<>'private'  OR (t2.pseudo_id IN (".$pseudosStr.") AND t1.id=t2.forum_id AND t2.host_id=".$hostid.")) AND t3.id=t1.pseudo_id";
    $output=$this->sql_getAll($query);

    return $output;
  }

  function customrenameforum($fid,$name,$uid, $host) {
    $query="REPLACE `gls_customnames` SET customname='".$name."', `forum_id`=".intval($fid).", `user_id`=".intval($uid).", host_id=".intval($host);
    $this->sql_query($query);
    return true;
  }

  function subscribe_f($p,$uid,$y) {
    while (list($k, $v) = each($p)) {
      if ((substr($k,0,3)=='chb') && ($v=='on')) {
        if ($y){
          $this->subscribe(substr($k,3),$uid);
        }else{
          //        print substr($k,3)." ";
          $this->unsubscribe(substr($k,3),$uid);
        }
      }
    }
  }


  function subscribe($forumid,$userid) {
    $forumid=intval($forumid);
    $userid=intval($userid);
    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_subscribtions WHERE user_id=$userid AND forum_id=$forumid"));
    if ($row1['count(*)']==0){
      mysql_query("INSERT INTO gls_subscribtions SET  user_id=$userid, forum_id=$forumid");
    }
  }

  function unsubscribe($forumid,$userid) {
    $forumid=intval($forumid);
    $userid=intval($userid);
    $sql="DELETE FROM gls_subscribtions WHERE (user_id=$userid) AND (forum_id=$forumid) LIMIT 1";
    $this->sql_query($sql);
  }

  function getcreatorname($id) {
    $id=intval($id);
    $row1=mysql_fetch_array(mysql_query("SELECT gls_pseudos.id, gls_pseudos.name FROM gls_pseudos,gls_forums WHERE (gls_forums.id=$id) && (gls_forums.pseudo_id=gls_pseudos.id);"));
    return $row1;
  }

  function forum2folder($fid,$uid){
    $query="SELECT folder_id FROM `gls_forums2folders` WHERE `forum_id`=".intval($fid);
    $row=@mysql_fetch_assoc(mysql_query($query));
    return $row['folder_id'];

  }

  function subscribed($forumid,$userid) {
    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_subscribtions WHERE user_id=".intval($userid)." AND forum_id=".intval($forumid)));
    if ($row1['count(*)']==0) {return 'N';} else {return 'Y';}
  }

  //   
  function getfolderslist($id){
    $id=intval($id);
    $output=array();
    $query="SELECT * FROM `gls_folders` WHERE `type`='RootTree' AND `user_id`=".$id;
    $rootNode=mysql_fetch_assoc(mysql_query($query));

    $query="SELECT * FROM `gls_folders` WHERE left_id BETWEEN ".$rootNode['left_id']." AND ".$rootNode['right_id']."
      AND parent_id=".$rootNode['id']." AND id!=".$rootNode['id']." ORDER BY left_id";
    $result=mysql_query($query);
    while ($row = mysql_fetch_assoc($result)) {
      $output[$row['id']]=$row;
    }

    foreach ($output as$v)

    return $output;

  }

  function changeforumcom1($id,$newname) {
    mysql_query("UPDATE gls_forums SET comment='$newname' WHERE id=".intval($id));
    return true;
  }

  function changeforumcom2($id,$newname) {
    mysql_query("UPDATE gls_forums SET comment2='$newname' WHERE id=".intval($id));
    return true;
  }

  function countProblems($userid){
    $sql="SELECT COUNT(*) as cnt FROM `gls_pseudos` t1, wm_problems t2 WHERE t1.user_id=".intval($userid)." AND t1.id=t2.pseudo_id";
    $data=$this->sql_getOne($sql);
    return $data['cnt'];
  }

  function getAllInvitation(&$inv, $userid, $level, $maxLevel=-1){ // for frus-forum
    $userid=intval($userid);
    //    print $pseudoid." -> ";
    $sql="SELECT * FROM `gls_users` WHERE `user_invited`=".$userid;
    $users=$this->sql_getAll($sql);

    foreach ($users as $user) {
      $inv[]=array(
      'level'=>$level,
      'id'=>$user['id'],
      'name'=>$user['login'],
      'host_id'=>0,
      'problems'=>$this->countProblems($user['id'])
      );
      if (($maxLevel==-1)or($maxLevel!=$level)){
        $this->getAllInvitation($inv, $user['id'], $level+1, $maxLevel);
      }

    }

  }

  //    ,   dbaccesses.class.php
  function getrights($forumid, $userid=null, $key=''){

    $a['d']=ACCESS_DENY;
    $a['r']=ACCESS_READ; //   ,    
    $a['w']=ACCESS_WRITE;
    $a['a']=ACCESS_ADMIN;

    $forumid=intval($forumid);


    if ($userid==null){ //  

  $query="SELECT * FROM gls_accesses WHERE forum_id=$forumid AND pseudo_id=1";

      $data=$this->sql_getAll($query);

      if ($data)
      {
          switch ($data[0]['rights_deny'])
          {
            case 'd' : return ACCESS_DENY ; break ;
            case 'r' : return ACCESS_READ ; break ;
            case 'w' : return ACCESS_WRITE ; break ;
            case 'a' : return ACCESS_ADMIN ; break ;
          }
      }

      $access1=ACCESS_DENY;


      $query="SELECT t1.id, t1.name, t3.name AS pseudo, t1.access, t2.type
    FROM `gls_forums` t1, gls_folders t2, gls_pseudos t3
    WHERE (t2.type='PublicForum' OR
    (t2.type='MainBox' AND (t1.access='public' OR t1.access='semipublic')) OR
    (t2.type='UserFolder' AND (t1.access='public' OR t1.access='semipublic')) ) AND
    (t1.folder_id=t2.id AND t3.id=t1.pseudo_id) AND t1.id=$forumid";
      $result=mysql_query($query);
      if ($row = @mysql_fetch_assoc($result)) {
        if ($row['type']=='PublicForum'){
          $access1 = ACCESS_WRITE;
        }

        switch ($row['access']) {
          case 'semipublic':
          $access1 = ACCESS_READ;
          break;

          case 'public':
          $access1 = ACCESS_WRITE;
          break;

          default:
          $access1 = ACCESS_DENY;
          break;
        }
      }else{
        $access1 = ACCESS_DENY;
      }

      if ($key==''){
        return $access1;
      }

      $query="SELECT * FROM `gls_accesses_email` WHERE forum_id = '".$forumid."' and `key`='".mysql_escape_string($key)."'";

      $result=mysql_query($query);
      if ($row=@mysql_fetch_assoc($result)){
        if ($a[$row['rights']]>$access1){
          return $a[$row['rights']];
        }else{
          return $access1;
        }
      }else{
        return $access1;
      }

    }else{
      //    
      $userid=intval($userid);
      $query="SELECT * FROM gls_forums WHERE id=$forumid";
      $data=$this->sql_getOne($query);
      if ($data['user_id']==$userid){
        return ACCESS_OWNER;
      }
      if ($data['access']=='semipublic'){
        return ACCESS_READ;
      }
      if ($data['access']=='public'){
        return ACCESS_WRITE;
      }
      //      
      $query="SELECT DISTINCT t1.* FROM gls_accesses t1, gls_pseudos t2 WHERE t1.forum_id=$forumid AND t1.pseudo_id=t2.id AND t2.user_id=$userid and host_id=0";
      $data=$this->sql_getAll($query);
      $access=ACCESS_DENY;

      foreach ($data as $k => $v) {
        if ($a[$v['rights']]<$a[$v['rights_deny']]){
          $cr=$v['rights'];
        }else{
          $cr=$v['rights_deny'];
        }
        switch ($cr) {
          case 'a':
          $r=ACCESS_ADMIN;
          break;

          case 'w':
          $r=ACCESS_WRITE;
          break;

          case 'r':
          $r=ACCESS_READ;
          break;

          case 'd':
          $r=ACCESS_DENY;
          break;
        }
        if ($r>$a[$v['rights_deny']]){
          $access=$v['rights_deny'];
        }elseif ($r>$access){
          $access=$r;
        }
      }
      return $access;
    }
  } //function getrights is over

  function getRemoteRights($forumid, $pseudoStr){
    $a['d']=ACCESS_DENY;
    $a['r']=ACCESS_READ; //   ,    
    $a['w']=ACCESS_WRITE;
    $a['a']=ACCESS_ADMIN;

    $forumid=intval($forumid);
    $pseudoStr=mysql_escape_string($pseudoStr);

    $forum=$this->sql_getOne("SELECT * FROM `gls_forums` WHERE id=$forumid");
    if ($forum['access']=='public'){
      return array('MaxAccess'=>ACCESS_WRITE,'type'=>'public','pseudosAccess'=>array());
    }
    if ($forum['access']=='semipublic'){
      return array('MaxAccess'=>ACCESS_READ,'type'=>'semipublic','pseudosAccess'=>array());
    }

    $access=array('MaxAccess'=>ACCESS_DENY,'pseudosAccess'=>array());

    $query="SELECT DISTINCT t1.*, t2.pseudo_id AS r_pseudo_id, t2.rights_deny, t2.rights, t3.type
    FROM `gls_forums` t1, `gls_accesses` t2, `gls_folders` t3
    WHERE  t1.id=$forumid AND t2.forum_id=$forumid AND t2.pseudo_id IN ($pseudoStr) AND t1.folder_id=t3.id";

    $result=mysql_query($query);
    while ($row = @mysql_fetch_assoc($result)) {
      $a1=ACCESS_DENY;

      if ($row['type']=='PublicForum'){
        $a1=ACCESS_WRITE;
      }else{

        switch ($row['access']) {
          case 'semipublic':
          $a1=ACCESS_READ;
          break;

          case 'public':
          $a1=ACCESS_WRITE;
          break;

          default:
          break;
        }
      }

      if ($a1>$a[$row['rights_deny']]){
        $a1=$row['rights_deny'];
      }

      if ($a1>$access['MaxAccess']){
        $access['MaxAccess']=$a1;
      }
      $access['pseudosAccess'][$row['r_pseudo_id']]=$a1;

      if ($a[$row['rights']]<$a[$row['rights_deny']]){
        $cr=$row['rights'];
      }else{
        $cr=$row['rights_deny'];
      }

      switch ($cr) {
        case 'r':
        $a2=ACCESS_READ;
        break;

        case 'w':
        $a2=ACCESS_WRITE;
        break;

        case 'a':
        $a2=ACCESS_ADMIN;
        break;

        default:
        $a2=ACCESS_DENY;
        break;
      }


      if ($a2>$a[$row['rights_deny']]){
        $a2=$row['rights_deny'];
      }

      if ($a2>$access['MaxAccess']){
        $access['MaxAccess']=$a2;
      }
      if ($a2>$access['pseudosAccess'][$row['r_pseudo_id']]){
        $access['pseudosAccess'][$row['r_pseudo_id']]=$a2;
      }
    }

    return $access;
  }

  function getpseudosrights($pseudoid,$forumid,$host=0){
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $pseudoid=intval($pseudoid);
    $forumid=intval($forumid);
    $host=intval($host);

    $query="SELECT * FROM gls_forums WHERE id=$forumid";
    $data=$this->sql_getOne($query);

    if (($data['pseudo_id']==$pseudoid)and($host==0)){

      return ACCESS_OWNER;
    }
    if ($data['access']=='semipublic'){
      return ACCESS_READ;
    }
    if ($data['access']=='public'){
      return ACCESS_WRITE;
    }


    //      
    $query="SELECT * FROM gls_accesses WHERE forum_id=$forumid AND pseudo_id=$pseudoid and host_id=$host";
    $data=$this->sql_getOne($query);

    if ($data){
      if ($a[$data['rights']]<$a[$data['rights_deny']]){
        $cr=$data['rights'];
      }else{
        $cr=$data['rights_deny'];
      }
      //      print $cr;
      switch ($cr) {
        case 'a':
        return ACCESS_ADMIN;
        break;

        case 'w':
        return ACCESS_WRITE;
        break;

        case 'r':
        return ACCESS_READ;
        break;

        default:
        break;
      }
    }
    return ACCESS_DENY;

  }

  function getuserright($userid,$forumid){ //    
    $a['d']=-1;
    $a['r']=1; //   ,    
    $a['w']=2;
    $a['a']=3;
    $a['o']=4;

    $userid=intval($userid);
    $forumid=intval($forumid);

    $query="SELECT * FROM `gls_pseudos` WHERE user_id=$userid";
    $data=$this->sql_getAll($query);
    $access=ACCESS_DENY;
    foreach ($data as $row) {
      $r=$this->getpseudosrights($row['id'],$forumid);
      $access=($r > $access) ? $r : $access;
    }
    return $access;
    //    print_r($data);

  }

  function folderinfo($forumid){
    $forumid=intval($forumid);
    $query="SELECT * FROM `gls_forums` WHERE id=$forumid";
    $data=$this->sql_getOne($query);

    $query="SELECT * FROM `gls_folders` WHERE id=".$data['folder_id'];
    $data=$this->sql_getOne($query);
    return $data;
  }

  function getForumOwner($forumid){
    $forumid=intval($forumid);
    $sql="SELECT t1.id, t1.login FROM `gls_users` t1, `gls_forums` t2 WHERE t2.id=".$forumid." AND t1.id=t2.user_id";
    return $this->sql_getOne($sql);
  }

  function foruminfo($forumid, $userid=0){
    $forumid=intval($forumid);
    $query="SELECT * FROM `gls_forums` WHERE id=$forumid";
    $data=$this->sql_getOne($query);
      $data['comment'] = str_replace ('<', '&lt;', $data['comment']) ;
      $data['comment'] = str_replace ('>', '&gt;', $data['comment']) ;
      $data['comment2'] = str_replace ('<', '&lt;', $data['comment2']) ;
      $data['comment2'] = str_replace ('>', '&gt;', $data['comment2']) ;

    $data['realname']=$data['name'];
    $data['name']=$this->getCustomName($data['id'],$userid, $data['name']);
      $data['name'] = str_replace ('<', '&lt;', $data['name']) ;
      $data['name'] = str_replace ('>', '&gt;', $data['name']) ;

    $data['owner']=$this->isOwner($forumid, $userid);

        if (isset($_SESSION['rinf'])) $ct = $this->glsDba->gettranslation($this->gettranslationindex4user("pizda"));
        else
        {
                $ct = $this->glsDba->gettranslation($this->gettranslationindex4user($_SESSION['finf']['userid']));
        }

    switch ($data['access'])
    {
            case 'private': $data['accesstype'] = $ct[283]; break ;
            case 'semipublic': $data['accesstype'] = $ct[282]; break ;
            case 'public': $data['accesstype'] = $ct[281]; break ;
            default : $data['accesstype'] = '' ;
    }
    return $data;
  }

  function addnewthread($id,$newname) {
    mysql_query("INSERT INTO gls_threads VALUES (0,'".mysql_escape_string($newname)."',".intval($id).",NOW(),'N');");
  }

  function deletethread($id) {
    $id=intval($id);
    if ($id==0){return false;}
    mysql_query("DELETE FROM gls_threads WHERE id=$id;");
    mysql_query("DELETE FROM gls_messages WHERE thread_id=$id;");
    mysql_query("DELETE FROM gls_threads_lastvisits WHERE thread_id=$id;");
    return true;
  }

  function renamethread($id,$newname) {
    mysql_query("UPDATE gls_threads SET name='".mysql_escape_string($newname)."' where id=".intval($id));
    return true;
  }

  function newreply($threadid,$pseudoid,$title,$body,$valid, $hostid=0)
  {
    if ($valid) {$v='Y';} else {$v='N';}
    $threadid=intval($threadid);
    $pseudoid=intval($pseudoid);
//    $title=mysql_escape_string($title);
//    $body=mysql_escape_string($body);
    $forumid=$this->thread2forum($threadid);
    $hostid=intval($hostid);

    $data=$this->sql_getOne("SELECT * FROM `gls_pseudos` WHERE id=$pseudoid");
    $query="INSERT INTO gls_messages SET pseudo_id=$pseudoid, forum_id=$forumid, thread_id=$threadid, user_id=".$data['user_id'].", header='$title', body='$body', created=NOW(), valid='$v',already_read='N', host_id=".$hostid;
    mysql_query($query);
    return mysql_insert_id();
  }

  function newRemoteReply($threadid,$pseudoid,$title,$body,$valid,$userid,$hostid)
  {
    if ($valid) {$v='Y';} else {$v='N';}
    $threadid=intval($threadid);
    $pseudoid=intval($pseudoid);
    $userid=intval($userid);
//    $title=mysql_escape_string($title);
//    $body=mysql_escape_string($body);
    $forumid=$this->thread2forum($threadid);
    $hostid=intval($hostid);

    $query="INSERT INTO gls_messages SET pseudo_id=$pseudoid, forum_id=$forumid, thread_id=$threadid, user_id=".$userid.", header='$title', body='$body', created=NOW(), valid='$v',already_read='N', host_id=$hostid";

    mysql_query($query);
    return mysql_insert_id();
  }

  function countnewatthread($threadid,$userid) {
    $threadid=intval($threadid);
    $userid=intval($userid);
    $row1=mysql_fetch_array(mysql_query("select count(*) from gls_threads_lastvisits where (thread_id=$threadid) && (user_id=$userid);"));
    if ($row1['count(*)']!=0) {
      $row1=mysql_fetch_array(mysql_query("select `when` from gls_threads_lastvisits where (thread_id=$threadid) && (user_id=$userid);"));
      $row2=mysql_fetch_array(mysql_query("select count(*) from gls_messages where (gls_messages.valid='Y') && (gls_messages.created>'".$row1['when']."') && (thread_id=$threadid);"));
      return $row2['count(*)'];
    } else {
      $row2=mysql_fetch_array(mysql_query("select count(*) from gls_messages where (gls_messages.valid='Y') && (thread_id=$threadid);"));
      return $row2['count(*)'];
    }
  }

  function getthreadslist($forumid, $userid){
    $forumid=intval($forumid);
    $userid=intval($userid);

    if ($this->getrights($forumid, $userid)>ACCESS_DENY){
      $query="SELECT * FROM `gls_threads` WHERE `forum_id`=".intval(@$_GET['id']);
      $threads=$this->sql_getAll($query);
      foreach ($threads as $k => $v) {
        $v['new']=$this->getCountNewMessThread($v['id'],$userid);
        $threads[$k]=$v;
      }
      return $threads;
    }else{
      return array();
    }
  }

  function getmessageslist($threadid,$userid){
    $threadid=intval($threadid);
    $userid=intval($userid);


    $query="SELECT * FROM `gls_pseudos`";
    $res=$this->sql_getAll($query);
    $pseudos=array();
    foreach ($res as $row){
      $pseudos[$row['id']]=$row;
      //      if ($row['user_id']==$userid){
      //        $pseudo_id[]=$row['id'];
      //      }
    }

    //    if (count($pseudo_id)>0){
    //      $str_pseudos=' OR '.implode($pseudo_id,',');
    //
    //    }
    $myarr=array();
    $res1=mysql_query("SELECT gls_messages.* FROM gls_messages WHERE (gls_messages.thread_id=$threadid) && (gls_messages.valid='Y' OR `user_id`=".$userid.") ORDER BY gls_messages.created;");
    while ($row1=mysql_fetch_assoc($res1)) {
        $row1['body'] = str_replace ('<', '&lt;', $row1['body']) ;
        $row1['body'] = str_replace ('>', '&gt;', $row1['body']) ;
        $row1['header'] = str_replace ('<', '&lt;', $row1['header']) ;
        $row1['header'] = str_replace ('>', '&gt;', $row1['header']) ;
      if ($row1['pseudo_id']==0){ // guest
        $row1['name']='guest';
        $row1['comment']='';
        $row1['pseudoid']=0;
      }elseif ($row1['pseudo_id']==-1){ // email
        $row1['name']=$row1['mail'];
        $row1['comment']='';
        $row1['pseudoid']=-1;
      }else{
        if (!isset($pseudos[$row1['host_id']][$row1['pseudo_id']])){
          $pseudos[$row1['host_id']][$row1['pseudo_id']]=$this->getpseudodata($row1['pseudo_id'],$row1['host_id']);
        }
        $row1['host_name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['host_name'];
        $row1['name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['name'];
        $row1['comment']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['comment'];
        $row1['pseudoid']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['id'];
      }
      array_push($myarr,$row1);
    }

    $query="UPDATE `gls_messages` SET `already_read`='Y' WHERE thread_id=".intval($threadid)." AND user_id<>".intval($userid)." AND valid='Y'";
    mysql_query($query);

    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_threads_lastvisits WHERE (thread_id=$threadid) && (user_id=$userid);"));
    if ($row1['count(*)']!=0) {
      mysql_query("UPDATE gls_threads_lastvisits SET `when`=NOW() WHERE (thread_id=$threadid) && (user_id=$userid);");
    } else {
      mysql_query("INSERT INTO gls_threads_lastvisits VALUES ($threadid,$userid,NOW());");
    }
    return $myarr;

  }

  function threadMembers($idthread){
    $idthread=intval($idthread);

    $output=array();
    $query="SELECT DISTINCT t1.* FROM gls_pseudos t1, gls_messages t2 WHERE t2.pseudo_id=t1.id AND t2.thread_id=".$idthread." AND t2.host_id=0";
    $result=mysql_query($query);
    while ($row = mysql_fetch_assoc($result)) {
      $output[0][$row['id']]=$row;
    }
    $query="SELECT DISTINCT pseudo_id, host_id FROM gls_messages WHERE thread_id=".$idthread." AND host_id<>0 ORDER BY host_id";
    $result=mysql_query($query);
    $host=0;
    $id=array();
    while ($row = mysql_fetch_assoc($result)) {
      $id[]=$row['pseudo_id'];
      if (($host!=$row['host_id'])and($host!=0)){
        $data=$this->remoteCall($host,"getcontactlist",array(serialize($id)));
        if ($pseudo=@unserialize($data[1])){
          foreach ($pseudo as $v) {
            $output[$host][$v['id']]=$v;
          }
        };
        $id=array();
      }
      $host=$row['host_id'];
    }
    if ($host!=0){
      $data=$this->remoteCall($host,"getcontactlist",array(serialize($id)));
      if ($pseudo=@unserialize($data[1])){
        foreach ($pseudo as $v) {
          $output[$host][$v['id']]=$v;
        }
      };
    }
    return $output;

  }

  function threadsexist($forumid)
  {
    $res1=mysql_query("SELECT COUNT(*) FROM gls_threads WHERE forum_id=".intval($forumid));
    $row1=mysql_fetch_array($res1);
    if ($row1['COUNT(*)']==1) return false; else return true;
  }

  function thread2forum($id) {
    $res1=mysql_query("SELECT forum_id FROM gls_threads WHERE id=".intval($id));
    $row1=mysql_fetch_array($res1);
    return $row1['forum_id'];
  }

  function canviewinv($uid,$fid,$rights) {
    $uid=intval($uid);
    $fid=intval($fid);

    if ($rights=='a') {return false;}
    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_accesses,gls_pseudos WHERE (gls_accesses.forum_id=$fid) && (gls_accesses.pseudo_id=gls_pseudos.id) && (gls_pseudos.user_id=$uid) && (gls_accesses.view_inv='Y');"));
    return ($row1['count(*)']!=0) ? true : false;
  }

  function gettranslist($pseudo_id)
  {
    $myarr=array();
    $access['public'] = 'public';
    $access['private'] = 'private';
    $pseudo_id = intval($pseudo_id);
    $query="SELECT forums_lang_translations.*, forums_lang_zones.stitle AS lang FROM forums_lang_translations,forums_lang_zones WHERE (forums_lang_zones.id=forums_lang_translations.zone_id) && (forums_lang_zones.stitle!='') and (forums_lang_translations.access = '".$access['public']."' or (forums_lang_translations.access = '".$access['private']."' and forums_lang_translations.pseudo_id = ".intval($pseudo_id).")) ORDER BY pseudo_id, lang, create_date, version;";
    $res1=mysql_query($query);
    while ($row1=mysql_fetch_assoc($res1)) {
    	$sql = "select name, id from gls_pseudos where user_id = '".intval($row1['pseudo_id'])."'";
    	$res = mysql_query($sql);
    	$ps = mysql_fetch_array($res);
    	$row1['user_id'] = $row1['pseudo_id'];
    	$row1['pseudo_id'] = intval($ps['id']);
    	$row1['name'] = $ps['name'];
      array_push($myarr,$row1);
    }
    return $myarr;
  }

  function getpseudoslist($userid)
  {
    $myarr=array();
    $res1=mysql_query("SELECT * FROM gls_pseudos WHERE user_id=".intval($userid));
    while ($row1=mysql_fetch_assoc($res1)) {
      $myarr[]=array("id"=>$row1['id'],"name"=>$row1['name']);
    }
    return $myarr;
  }

  function canresign($uid,$fid) {
    $uid=intval($uid);
    $fid=intval($fid);

    $row1=mysql_fetch_array(mysql_query("SELECT gls_pseudos.user_id FROM gls_pseudos,gls_forums WHERE (gls_forums.pseudo_id=gls_pseudos.id) && (gls_forums.id=$fid);"));
    if ($row1['user_id']==$uid) {return false;} else {return true;}
  }

  function markvalid($userid,$messageid){
    $userid=intval($userid);
    $messageid=intval($messageid);

    $res1=mysql_query("SELECT gls_pseudos.user_id FROM gls_messages,gls_pseudos WHERE (gls_messages.id=$messageid) and (gls_pseudos.id=gls_messages.pseudo_id);");
    $row1=mysql_fetch_array($res1);
    if ($row1['user_id']==$userid) {
      mysql_query("UPDATE gls_messages SET valid='Y' WHERE id=$messageid");
    }
  }

  function markvalidRemote($userid,$messageid, $hostid){
    $userid=intval($userid);
    $hostid=intval($hostid);
    $messageid=intval($messageid);

    $sql="UPDATE gls_messages SET valid='Y', created=NOW() WHERE id=$messageid AND pseudo_id=".$userid." AND host_id='".$hostid."'";
//    print $sql;
    $this->sql_query($sql);
  }

  function markinvalidRemote($userid,$messageid, $hostid){
    $userid=intval($userid);
    $hostid=intval($hostid);
    $messageid=intval($messageid);

    $sql="UPDATE gls_messages SET valid='N' WHERE id=$messageid AND pseudo_id=".$userid." AND host_id='".$hostid."'";
    $this->sql_query($sql);
  }

  function markvalidmail($mail,$messageid){
    $mail=mysql_escape_string($mail);
    $messageid=intval($messageid);

    $this->sql_query("UPDATE gls_messages SET valid='Y', created=NOW() WHERE id=$messageid AND pseudo_id=-1 AND mail='".$mail."'");
  }

  function markinvalidmail($mail,$messageid){
    $mail=mysql_escape_string($mail);
    $messageid=intval($messageid);

    $this->sql_query("UPDATE gls_messages SET valid='N' WHERE id=$messageid AND pseudo_id=-1 AND mail='".$mail."'");
  }

  function markinvalid($userid,$messageid){
    $userid=intval($userid);
    $messageid=intval($messageid);
    $res1=mysql_query("SELECT gls_pseudos.user_id FROM gls_messages,gls_pseudos WHERE (gls_messages.id=$messageid) AND (gls_pseudos.id=gls_messages.pseudo_id);");
    $row1=mysql_fetch_array($res1);
    if ($row1['user_id']==$userid) {
      mysql_query("UPDATE gls_messages SET valid='N' WHERE id=$messageid;");
    }
  }

  function message2thread($messageid)
  {
    $res1=mysql_query("SELECT thread_id FROM gls_messages WHERE gls_messages.id=".intval($messageid));
    $row1=mysql_fetch_array($res1);
    return $row1['thread_id'];
  }

  function getmessagetext($id) {
    $row1=mysql_fetch_array(mysql_query("SELECT body FROM gls_messages WHERE id=".intval($id)));
    return $row1['body'];
  }

  function getmessageheader($id) {
    $row1=mysql_fetch_array(mysql_query("SELECT header FROM gls_messages WHERE id=".intval($id)));
        $row1['header'] = str_replace ('\'', '&#039;', $row1['header']) ;
        $row1['header'] = str_replace ('"', '&quot;', $row1['header']) ;
    return $row1['header'];
  }

  function erasemessage($userid,$messageid)
  {
    $userid=intval($userid);
    $messageid=intval($messageid);

        $thread = $this->message2thread ($messageid) ;
        $forum = $this->thread2forum ($thread) ;
        $rights = $this->getRights ($forum, $userid) ;

    $res1=mysql_query("SELECT gls_pseudos.user_id FROM gls_messages,gls_pseudos WHERE (gls_messages.id=$messageid) AND (gls_pseudos.id=gls_messages.pseudo_id);");
    $row1=mysql_fetch_array($res1);
        $ret = mysql_query ("SELECT admin FROM gls_users WHERE id=$userid") ;
        $ret = mysql_fetch_array($ret);
        if ($ret['admin']=='Y' || $rights >= ACCESS_ADMIN)
        {
          mysql_query("DELETE FROM gls_messages WHERE id=$messageid AND host_id=0 LIMIT 1");
        }
        else if ($row1['user_id']==$userid)
        {
          mysql_query("DELETE FROM gls_messages WHERE id=$messageid AND already_read='N' AND host_id=0 LIMIT 1");
        }
  }

  function erasemessagemail($mail, $messageid)
  {
    $mail=mysql_escape_string($mail);
    $messageid=intval($messageid);

    $sql="DELETE FROM gls_messages WHERE id=$messageid AND `mail`='".$mail."' AND pseudo_id=-1 AND already_read='N' LIMIT 1";
    $this->sql_query($sql);
  }

  function erasemessageRemote($messageid, $userid, $hostid)
  {
    $messageid=intval($messageid);
    $userid=intval($userid);
    $hostid=intval($hostid);

    $sql="DELETE FROM gls_messages WHERE id=$messageid AND user_id=$userid AND pseudo_id=$userid AND already_read='N' AND host_id=$hostid LIMIT 1";
    $this->sql_query($sql);
  }

  function editmessage($id, $body, $userid, $title=null, $mail='', $hostid=0){
    $hostid=intval($hostid);
    if ($title!=null){
      $header="`header`='$title',";
    }else{
      $header='';
    }
    if (($mail=='')and($userid!=-1)){
      $sql="UPDATE gls_messages SET ".$header."`body`='$body' WHERE id=".intval($id)." AND user_id=".intval($userid)." AND host_id=".$hostid;
    }else{
      $sql="UPDATE gls_messages SET ".$header."`body`='$body' WHERE id=".intval($id)." AND pseudo_id=".intval($userid)." AND `mail`='".mysql_escape_string($mail)."'";
    }

    $this->sql_query($sql);
  }

  function editmessageRemote($id,$body,$userid,$hostid, $title=null) {
    if ($title!=null){
      $header="`header`='".mysql_escape_string($title)."',";
    }else{
      $header='';
    }
    $sql="UPDATE gls_messages SET ".$header."`body`='".mysql_escape_string($body)."'
    WHERE id=".intval($id)." AND user_id=".intval($userid)."  AND pseudo_id=".intval($userid)." AND host_id=".intval($hostid);

    print $sql;
    $this->sql_query($sql);
  }

  function getPUBLICforumslist($key='')
  {
    //         public  semipublic  
    $query="SELECT t1.id, t1.name, t3.name AS pseudo FROM `gls_forums` t1, gls_folders t2, gls_pseudos t3
    WHERE (t2.type='PublicForum' OR
    (t2.type='MainBox' AND (t1.access='public' OR t1.access='semipublic')) OR
    (t2.type='UserFolder' AND (t1.access='public' OR t1.access='semipublic')) ) AND
    (t1.folder_id=t2.id AND t3.id=t1.pseudo_id)";

    $res2=mysql_query($query);
    $myarr=array();
    while ($row2=mysql_fetch_assoc($res2)) {array_push($myarr,$row2);}

    if ($key!=''){
      $query="SELECT t1.id, t1.name, t3.name AS pseudo FROM `gls_forums` t1, gls_accesses_email t2, gls_pseudos t3
    WHERE t1.id=t2.forum_id AND t2.key='".mysql_escape_string($key)."' AND t3.id=t1.pseudo_id";

      $res2=mysql_query($query);
      while ($row2=mysql_fetch_assoc($res2)) {array_push($myarr,$row2);}
    }
    return $myarr;

  }

  function getPUBLICmessageslist($threadid, $mail=''){
    $mail=mysql_escape_string($mail);
    $threadid=intval($threadid);
    $query="SELECT * FROM `gls_pseudos`";
    $res=$this->sql_getAll($query);
    $pseudos=array();
    foreach ($res as $row){
      $pseudos[$row['id']]=$row;
    }

    $threadid=intval($threadid);
    $myarr=array();
    $sql="SELECT gls_messages.* FROM gls_messages WHERE (gls_messages.thread_id=$threadid) AND ((gls_messages.valid='Y') OR (`mail`='".$mail."')) ORDER BY gls_messages.created";
    $res1=mysql_query($sql) or mysql_error();
    while ($row1=mysql_fetch_assoc($res1)){
        $row1['body'] = str_replace ('<', '&lt;', $row1['body']) ;
        $row1['body'] = str_replace ('>', '&gt;', $row1['body']) ;
        $row1['header'] = str_replace ('<', '&lt;', $row1['header']) ;
        $row1['header'] = str_replace ('>', '&gt;', $row1['header']) ;
      if ($row1['pseudo_id']==0){
        $row1['name']='guest';
        $row1['comment']='';
        $row1['pseudoid']=0;
      }elseif ($row1['pseudo_id']==-1){
        $row1['name']=$row1['mail'];
        $row1['comment']='';
        $row1['pseudoid']=-1;
      }else{
        if (!isset($pseudos[$row1['host_id']][$row1['pseudo_id']])){
          $pseudos[$row1['host_id']][$row1['pseudo_id']]=$this->getpseudodata($row1['pseudo_id'],$row1['host_id']);
        }

        $row1['host_name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['host_name'];
        $row1['name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['name'];
        $row1['comment']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['comment'];
        $row1['pseudoid']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['id'];
      }
      array_push($myarr,$row1);
    }

    if ($mail){
      $query="UPDATE `gls_messages` SET `already_read`='Y' WHERE thread_id=".intval($threadid)." AND valid='Y' AND mail<>'".$mail."'";
    }else{
      $query="UPDATE `gls_messages` SET `already_read`='Y' WHERE thread_id=".intval($threadid)." AND valid='Y'";
    }
    mysql_query($query);

    return $myarr;
  }

  function getREMOTEmessageslist($threadid, $userid, $hostid){
    $threadid=intval($threadid);
    $userid=intval($userid);
    $hostid=intval($hostid);

    $query="SELECT * FROM `gls_pseudos`";
    $res=$this->sql_getAll($query);
    $pseudos=array();
    foreach ($res as $row){
      $pseudos[$row['id']]=$row;
    }

    $threadid=intval($threadid);
    $myarr=array();
    $sql="SELECT gls_messages.* FROM gls_messages WHERE (gls_messages.thread_id=$threadid) AND ((gls_messages.valid='Y') OR ((`user_id`=".$userid." AND `pseudo_id`=".$userid.") AND host_id=".$hostid.")) ORDER BY gls_messages.created";
    $res1=mysql_query($sql);
    while ($row1=mysql_fetch_assoc($res1)) {
      if ($row1['pseudo_id']==0){
        $row1['name']='guest';
        $row1['comment']='';
        $row1['pseudoid']=0;
      }elseif ($row1['pseudo_id']==-1){
        $row1['name']=$row1['mail'];
        $row1['comment']='';
        $row1['pseudoid']=-1;
      }else{
        if (!isset($pseudos[$row1['host_id']][$row1['pseudo_id']])){
          $pseudos[$row1['host_id']][$row1['pseudo_id']]=$this->getpseudodata($row1['pseudo_id'],$row1['host_id']);
        }

        $row1['host_name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['host_name'];
        $row1['name']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['name'];
        $row1['comment']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['comment'];
        $row1['pseudoid']=$pseudos[$row1['host_id']][$row1['pseudo_id']]['id'];
        $row1['body'] = str_replace ('<', '&lt;', $row1['body']) ;
        $row1['body'] = str_replace ('>', '&gt;', $row1['body']) ;
        $row1['header'] = str_replace ('<', '&lt;', $row1['header']) ;
        $row1['header'] = str_replace ('>', '&gt;', $row1['header']) ;
      }
      array_push($myarr,$row1);
    }

    $query="UPDATE `gls_messages` SET `already_read`='Y'
    WHERE thread_id=".intval($threadid)." AND valid='Y' AND host_id<>".$hostid." AND pseudo_id<>".$userid;
    mysql_query($query);

    //    print_r($myarr);
    return $myarr;
  }

  function newPUBLICreply($threadid,$title,$body){

    $threadid = intval($threadid);

    $forumid=$this->thread2forum($threadid);

    if ($this->getrights($forumid)<ACCESS_WRITE) return;

    $query="INSERT INTO gls_messages SET
    `forum_id`=$forumid,
    `thread_id`=".intval($threadid).",
    `header`='".$title."',
    `body`='".$body."',
    `pseudo_id`=0,
    `created`=NOW(),
    `valid`='Y',
    `already_read`='N'";
    mysql_query($query);
  }

  function newMailReply($threadid,$title,$body,$mailid, $valid){
    $valid=($valid)?'Y':'N';
    //    $query="SELECT * FROM `gls_accesses_email` WHERE `email_id`=".intval($mailid);
    $query="SELECT DISTINCT t1.* FROM `gls_email` t1, `gls_accesses_email` t2 WHERE t2.email_id=".intval($mailid)." AND (t2.email_id=t1.id)";
    $res=$this->sql_getOne($query);

    $forumid=$this->thread2forum($threadid);
    $query="INSERT INTO `gls_messages` SET
    `forum_id`=$forumid,
    `thread_id`=".intval($threadid).",
    `header`='".$title."',
    `body`='".$body."',
    `mail`='".$res['email']."',
    `pseudo_id`=-1,
    `created`=NOW(),
    `valid`='".$valid."',
    `already_read`='N'";
    $this->sql_query($query);

    return mysql_insert_id();

  }

  function placeforum($forumid,$uid) {
    //                        $row1=mysql_fetch_array(mysql_query("select name from forums_forums where id=$forumid;"));
    //                        return '\''.$row1['name'].'\'';
    $forumid=intval($forumid);
    $uid=intval($uid);
    if ($uid!=-1) {
      return '\''.$this->forum2ndname($forumid,$uid).'\'';
    } else {
      $row1=mysql_fetch_array(mysql_query("SELECT name FROM gls_forums WHERE id=$forumid;"));
      return '\''.$row1['name'].'\'';
    }
  }

  function guestcanreply($id) {
    $row1=mysql_fetch_assoc(mysql_query("SELECT count(*) FROM gls_blacklist WHERE (pseudo_id=1) && (forum_id=".intval($id).");"));
    if ($row1['count(*)']==1) {return false;} else {return true;}
  }

  function pseudoexists($name) {
    $row1=mysql_fetch_array(mysql_query("SELECT count(*) FROM gls_pseudos WHERE name='".mysql_escape_string($name)."';"));
    if ($row1['count(*)']==0) {return false;} else {return true;}
  }

  function pseudo2userid($pseudoid){
    $pseudoid=intval($pseudoid);
    $sql="SELECT * FROM `gls_pseudos` WHERE id=".$pseudoid;
    $res=$this->sql_getOne($sql);
    if (isset($res['user_id'])){
      return $res['user_id'];
    }else{
      return false;
    }
  }

  function getRemoteForums($hostid, $pseudos){
    $hostid=intval($hostid);
    $s='';
    foreach ($pseudos as $p) {
      $s.=intval($p).", ";
    }
    $s=substr($s,0,-2);

    $query="SELECT t1.id, t1.name, t2.pseudo_id FROM gls_forums t1, gls_accesses t2 WHERE t2.pseudo_id IN ($s) AND host_id=$hostid AND t1.id=t2.forum_id";
    return $this->sql_getAll($query);
  }

  // ************************     GLS    ************************

  function gotoRemoteForum($hostid,$forumid,$pseudoInfo,$pseudo){
    $host = $this->glsDba->getHost($hostid);
    if (!$host){
      return false;
    }

    $rndString=$this->openRemoteSession($pseudo, $hostid);
    $url=$host['address_base'].'?action=showremoteforum&id='.$forumid.'&rs='.urlencode($rndString).'&h='.urlencode(md5($GLOBALS['gls_cfg']['user_agent']));
    header("Location: $url");

    return true;
  }

  function gotoRemoteBookmark($idbookmark,$pseudoInfo, $pseudoId){
    $idbookmark=intval($idbookmark);
    $query="SELECT * FROM `gls_bookmark` WHERE id=".$idbookmark." AND user_id=".intval($pseudoInfo['userid']);
    $data=$this->sql_getOne($query);
    if (!$data){
      return false;
    }
    $hostid=$data['host_id'];

    $host = $this->glsDba->getHost($hostid);
    if (!$host){
      return false;
    }

    $rndString=$this->openRemoteSession($pseudoId, $hostid);
    $url=$host['address_base'].'?action=showremotebookmark&id='.$idbookmark.'&rs='.urlencode($rndString).'&h='.urlencode(md5($GLOBALS['gls_cfg']['user_agent']));
    header("Location: $url");

    return true;
  }

  function gotoDefaultBookmark($hostid,$pseudoInfo){
    $hostid=intval($hostid);

    $host = $this->glsDba->getHost($hostid);
    if (!$host){
      return false;
    }

    $rndString=$this->openRemoteSession($pseudoInfo, $hostid);
    $url=$host['address_base'].'?action=showremotebookmark&rs='.urlencode($rndString).'&h='.urlencode(md5($GLOBALS['gls_cfg']['user_agent']));
    header("Location: $url");

    return true;
  }

  function openRemoteSession($userId, $hostId) {
    $userId=intval($userId);
    $hostId=intval($hostId);
    $randString = mysql_escape_string(_newRandomString());

    mysql_query("REPLACE `gls_remote_session` SET rand_string='$randString', user_id=$userId, host_id=$hostId");
    return $randString;
  }

  function closeRemoteSession($hostId,$rndStr) {
    //    $hostId=intval($hostId);
    //    $rndStr = mysql_escape_string($rndStr);

    $this->remoteCall($hostId,"closeSession",array($rndStr));

    //    mysql_query("REPLACE `gls_remote_session` SET rand_string='$randString', user_id=$userId, host_id=$hostId");
    return true;
  }

  function addRemoteToBookmark($uri,$userid,$host){ //      bookmark
    $this->remoteCall($host,"bookmark_add_url",array($uri,$userid));
    return true;
  }

  function checkRemoteUser($rndStr, $remoteHost, $idbookmark=0){
    $query="SELECT * FROM `gls_host` WHERE md5(gls_url)='".mysql_escape_string($remoteHost)."'";
    $host=$this->sql_getOne($query);
    if (!$host){
      return false;
    }else{
      $output=$this->remoteCall($host['id'],"checkUser",array($rndStr,$idbookmark));
      if (!$output[1]){
        return false;
      }
      if (!$pseudos=@unserialize($output[1])){
        return false;
      }

      $userInfo=array();
      $userInfo['host_id']=$host['id'];
      $userInfo['host_name']=$host['name'];
      $userInfo['address_base']=$host['address_base'];
      $userInfo['pseudos']=$pseudos['pseudos'];
      $userInfo['user']=$pseudos['user'];
      $userInfo['rndString']=$rndStr;
      $userInfo['pseudosStr']=$pseudos['pseudos'][0]['id'];

      if (isset($pseudos['bookmarkURL'])){
        $userInfo['bookmarkURL']=$pseudos['bookmarkURL'];
      }

      return $userInfo;
    }
  }

  function bookmark_add_url($uri,$userid,$host){
    if ($this->mysql_count('gls_bookmark', "`user_id`=".intval($userid)." AND `host_id`=".intval($host)." AND `url`='".mysql_escape_string($uri)."'")==0){
      $query="INSERT INTO gls_bookmark SET `user_id`=".intval($userid).", `host_id`=".intval($host).", `url`='".mysql_escape_string($uri)."'";
      mysql_query($query);
    }
    //    write2file($query);
  }

  /*
  *  Finish Ivan Maroz
  */
}

?>