<?php

class IForm {

    /**
     * @access	public
     * @param	string	$name
     * @param	string	$property
     * @param	string	$def
     * @return	string
     * @return	array
     */
	function param($name, $property = null, $def = '') {
		$aProperties =& IForm::_load($name);

		if ($property === null) {
			return $aProperties;
		}

		if (array_key_exists($property, $aProperties)) {
			return $aProperties[$property];
		} else {
			return $def;
		}
	}

    /**
     * @access	public
     * @param	string	$param
     * @param	string	$value
     * @return	string
     */
	function checked($param, $value) {
		return IForm::_hasValue($param, $value) ? 'checked' : '';
	}

    /**
     * @access	public
     * @param	string	$param
     * @param	string	$value
     * @return	string
     */
	function selected($param, $value) {
		return IForm::_hasValue($param, $value) ? 'selected' : '';
	}

    /**
     * @access	public
     * @param	string	$param
     * @param	array	$values
     * @return	string
     */
	function option($param, $values) {
		$aOption = array();
		foreach ($values as $sKey => $sLabel) {
			$aOption[] = '<option '. IForm::selected($param, $sKey) .' value="'. $sKey .'">'. $sLabel .'</option>';
		}
		return implode("\n", $aOption);
	}

    /**
     * @access	private
     * @param	string	$param
     * @param	string	$value
     * @return	boolean
     */
	function _hasValue($param, $value) {
		if (is_array($param) && in_array($value, $param)) return true;
		if ($value == $param) return true;
		return false;
	}

    /**
     * @access	private
     * @param	string	$name
     * @return	array
     */
	function &_load($name) {
		require_once 'common/Action/ISession.class.php';
		if (ISession::has(IForm::name($name)))
			return ISession::get(IForm::name($name));
		else
			return array();
	}

    /**
     * @access	private
     * @param	string	$name
     * @return	string
     */
	function name($name) {
		return $name . '.param';
	}

}

?>
