<?php

class CGI {

	function CGI() {}

	function redirect($option = array()) {
		$option['-self'] = isset($option['-self']) ? $option['-self'] : true;

		// Get redirect-url
		require_once 'common/URL.class.php';
		$url = new URL(array('-url' => $option['-url'], '-self' => $option['-self']));

		// Put to query inputs params
		if (array_key_exists('-param', $option) && sizeOf($option['-param']) > 0) {
			$url->setParam($option['-param']);
		}

		if (array_key_exists('-cookie', $option) && is_array($option['-cookie'])) {
			$option['-cookie'] = array_merge(
				array('value'  => '', 'expire' => 0, 'path' => '', 'domain' => '', 'secure' => 0),
				$option['-cookie']
			);
			setCookie(
				$option['-cookie']['name'],
				$option['-cookie']['value'],
				$option['-cookie']['expire'],
				$option['-cookie']['path'],
				$option['-cookie']['domain'],
				$option['-cookie']['secure']
			);
		}

		header('Location: '. $url->getUrl());
		exit();
	}

	function forbidden() {
		header("HTTP/1.0 403 Forbidden");
		exit();
	}

	function param($sName, $sDef = '') {
		if (cgi::has('HTTP_GET_VARS', $sName))
			return $GLOBALS['HTTP_GET_VARS'][$sName];
		elseif (cgi::has('HTTP_POST_VARS', $sName))
			return $GLOBALS['HTTP_POST_VARS'][$sName];
		else
			return $sDef;
	}


	function has($sCollectionName, $sName) {
		return !@empty($GLOBALS[$sCollectionName][$sName]);
	}

}

?>
