<?php
require_once 'common/Database/Database.class.php';
require_once 'common/Database/SQL.class.php';

class Object_IEng {

        function _table() {
            return 'table';
        }

        /**
         * @access        public
         *
         * @param        object        $oObject
         *
         * @return        boolean
         */
        function save(&$oObject) {
                if ($oObject->isNew()) {
                        if (! Object_IEng::_create($oObject)) return false;
                } elseif ($oObject->isDirty()) {
                        if (! Object_IEng::_update($oObject)) return false;
                }

                $oObject->setNew(false);
                $oObject->setDirty(false);

                return true;
        }

        /**
         * @access        private
         *
         * @param         object        $oObject
         *
         * @return        boolean
         */
        function _create(&$oObject) {
			$sKey  = Object_IEng::_table().'.insert';
			$aParam = $oObject->getData();

			$oDb =& Database::getConnected(Conf::get('db'));
			if (! $oDb->execute(SQL::prepareQuery($sKey, $aParam)) )
				return false;

			$oObject->setID($oDb->getInsertID());

            return true;
        }

        /**
         * @access        private
         *
         * @param         object        $oObject
         *
         * @return        boolean
         */
        function _update(&$oObject) {
			$sKey     = Object_IEng::_table().'.update';
			$aParam   = $oObject->getData();
			$aParam[] = $oObject->getID());

			$oDb =& Database::getConnected(Conf::get('db'));
			return $oDb->execute(SQL::prepareQuery($sKey, $aParam));
        }

        /**
         * @access        public
         *
         * @param        object        $oObject
         *
         * @return        boolean
         */
        function remove(&$oObject) {
			if ($oObject->isNew())
				return true;

	        $sKey     = Object_IEng::_table().'.remove';
	        $aParam   = array($oObject->getID());

			$oDb =& Database::getConnected(Conf::get('db'));
			return $oDb->execute(SQL::prepareQuery($sKey, $aParam));
        }

        /**
         * @access        public
         *
         * @return        boolean
         */
        function removeBy($sKey, $aParam) {
	        $oQueryResult = Object_IEng::query($sKey, $aParam);
	        for ($i = 0; $i < $oQueryResult->getRowCount(); $i++) {
	            if (! Object_IEng::remove($oQueryResult->getRow($i)))
					return false;
	        }

	        return true;
        }

        /**
         * @access        public
         *
         * @return        false
         */
        function query($sKey, $aParam) {
			return false;
        }
}
?>
