<?php

class Pager {

	function Pager($nTotalRows = 0, $nPage = 1, $nStepRows = 1, $nStepPages = 1) {
		$this->nTotalRows = max(intVal($nTotalRows), 0);
		$this->nPage      = max(intVal($nPage),      1);
		$this->nStepRows  = max(intVal($nStepRows),  1);
		$this->nStepPages = max(intVal($nStepPages), 1);
	}

	function _index() {
		return min($this->nPage - 1, $this->totalPage() - 1);
	}

	function stepRows() {
		return $this->nStepRows;
	}

	function minRow() {
		return $this->nStepRows * $this->_index();
	}
	function maxRow() {
		return min($this->minRow() + $this->nStepRows, $this->nTotalRows);
	}

	function totalRows() {
		return $this->nTotalRows;
	}
	function fromRow() {
		return $this->minRow() + 1;
	}
	function toRow() {
		return $this->maxRow();
	}

	function totalPage() {
		return ceil($this->nTotalRows / $this->nStepRows);
	}
	function curentPage() {
		return $this->_index() + 1;
	}
	function prevPage() {
		return $this->_index();
	}
	function nextPage() {
		return $this->_index() + 2;
	}

}
