<?php

/***
 * $oDatabase = new Database('name', 'host');
 * $oDatabase->connect('username', 'password');
 *
 * $oQueryResult = new QueryResult($oDatabase, $sql);
 *
 * @see Database
 ***/

class QueryResult {

        // DATA MEMBERS

        /***
         * The database object
         * @type object Database
         ***/
        var $database;

        /***
         * The internal result identifier
         * @type integer
         ***/
        var $resultId;

        /***
         * The optional error message
         * @type string
         ***/
        var $errorMessage = '';

        /***
         * The current row index
         * @type int
         ***/
        var $currentRow;

        // CREATORS

    /***
     * Construct a new QueryResult
     ***/
        function QueryResult(&$database, $sql) {
                $this->database     =& $database;
                $this->currentRow   = 0;

                if (($this->resultId = $database->query($sql)) === false) {
                        $this->errorMessage = $database->getErrorMessage();
                }
        }

        // MANIPULATORS

        /***
         * Clear the result data from memory; this method need only be called if
         * memory usage is high in a single script. After calling this method, the
         * result can no longer be accessed.
         * @returns void
         ***/
        function clear() {
                mysql_free_result($this->getResultId());
        }

        // ACCESSORS

        /***
         * Get the internal result identifier; this is a protected method.
         * @returns int
         * @protected
         ***/
        function getResultId() {
                return $this->resultId;
        }

        /***
         * Get a reference to the database
         * @returns Database
         ***/
        function &getDatabase() {
                return $this->database;
        }

        /***
         * Check if the query was executed successfully
         * @returns bool
         ***/
        function isSuccess() {
                return ($this->resultId != 0);
        }

        /***
         * Get the error message; useful in case isSuccess() returns
         * false. Returns the empty string if there was no error.
         * @returns string
         ***/
        function getErrorMessage() {
                return $this->errorMessage;
        }

        /***
         * Get the number of rows in the result for a SELECT-query
         * @returns int
         ***/
        function getRowCount() {
                return mysql_num_rows($this->getResultId());
        }

        /***
         * Get the row at the specified index for a SELECT-query.
         * @param $index the index of the row to retrieve
         * @returns array
         ***/
        function getRow($index) {
                if ($index != $this->currentRow) {
                        mysql_data_seek($this->getResultId(), $index);
                }
                $this->currentRow = $index + 1;
                return mysql_fetch_assoc($this->getResultId());

        }

}
